unit Reimu;


//얲
interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ddsd, Ddidex, DGCarad9, s_mathpack, SXLib9,d3d9, AppEvnts,
  octettree, Game, defs, fighter, commonObj, util;

type

TReimu = class(TFighter)
  private
    Texture:TDGTexture;
    TamaTexture1:TDGTexture;
    TamaMesh1:TSXMesh;
    TamaTexture2:TDGTexture;
    Height:Single;  //w
    Width:Single;   //
    Depth:Single;   //Oa
    Velocity:D3DVector; //xxNg
    OnGround:Boolean; //ڒnĂ
    Dashing:Single; //_bVpA̒l0ɂȂOɂxWv{^ŃWv[h
    Lift:Single;    //g
    Locking:Boolean;        //U[Y/N]
    LockTransition:Single;  //UA0ŃbNJnA1.0ŊSɐU
  public
    constructor Create(AOwner:TMoverList; birthTime:Single; AController:TControllerType);
    destructor Destroy; override;
    procedure Die; override;
    procedure Move(dt:Single); override;
    function CheckTouch(Target:TMover):Boolean; override; //蔻
    procedure OnCrush(target:TMover); override;
    procedure OnDamaged(target:TMover; dmg:Integer); override;
    procedure CatchMessage(from:TMover; info1,info2:Integer; xInfo:Pointer); override;
end;

TReimuTama1 = class(TMover)
  private
    StartPos:D3DVector;
    Direction:D3DVector;
    Frame:TSXFrame;
    Shooter:TReimu;
    DropMode:Boolean; //ԂėĂ
    DropAxis:D3DVector; //Ԃė鎞̉]
    HitT:Single;      //Ԃ
  public
    constructor Create(AOwner:TMoverList; birthTime:Single; start,dir:D3DVector; AShooter:TReimu);
    destructor Destroy; override;
    procedure Move(dt:Single); override;
end;

TReimuTama2 = class(TTrailee)
  private
    Frame:TSXFrame;
    Shooter:TReimu;
    Position:D3DVector;
    Velocity:D3DVector;
    Theta:Integer;  //]ppx
    ClockWiseRotation:Boolean;  //]
  public
    constructor Create(AOwner:TMoverList; birthTime:Single; start,dir:D3DVector; AShooter:TReimu; clockwise:Boolean);
    destructor Destroy; override;
    procedure Move(dt:Single); override;
end;


implementation

{ TReimu }

procedure TReimu.CatchMessage(from: TMover; info1, info2: Integer;
  xInfo: Pointer);
begin
  inherited;

end;

function TReimu.CheckTouch(Target: TMover): Boolean;
begin
  result:=inherited CheckTouch(Target);
end;

constructor TReimu.Create(AOwner:TMoverList; birthTime: Single; AController: TControllerType);
begin
  inherited Create(AOwner, birthTime, AController);

  Controller:=AController;
  Attr:=AttrMyself(Controller);
  Height:=1.92; //1sNZ=6cmƂāA]݂192cmA`悳Ă͈͂150cmO
  Width:=Height*0.75;
  Depth:=Width;

  Texture:=TDGTexture.Create(DG, DGFMT_ARGB);
  Texture.LoadFromFile(PATH+'g\reimu_argb.bmp');
  TamaTexture1:=TDGTexture.Create(DG,DGFMT_ARGB);
  TamaTexture1.LoadFromFile(PATH+'g\reimu_tama1_argb.bmp');
  TamaMesh1:=TSXMesh.Create(DG);
  TamaMesh1.LoadFromFile(PATH+'g\reimu_tama1.sx');
  TamaTexture2:=TDGTexture.Create(DG,DGFMT_ARGB);
  TamaTexture2.LoadFromFile(PATH+'g\reimu_tama2_argb.bmp');

  OnGround:=False;
  Locking:=False;
end;

destructor TReimu.Destroy;
begin
  Texture.Free;
  TamaTexture1.Free;
  TamaTexture2.Free;
  TamaMesh1.Free;

  inherited;
end;

procedure TReimu.Die;
begin
  inherited;

end;

procedure TReimu.Move(dt: Single);
var
  hh:Single; //w̔
  hw:Single; //̔
  hd:Single;  //s̔
  iAnim:Integer;
  iDirection:Integer;
  oriZ,oriY:D3DVector;
  i:Integer;
  iCtrl:Integer;  //͂󂯂Rg[[̔ԍ
  bound:TEllipsoid3D;
  startPos,endPos:D3DVector;
  idFloor:Integer;  //\IuWFNg̔ԍ͉Ԃ
  debugStr:String;
  world_y,world_z:D3Dvector;  //[hWłY,ŹAǂH
  fwdbwd:D3DVector; //Oi/ރxNg
  q,q1,q2:TQuaternion;
  intencity:Single; //o[jA̖邳
  bulletDir:D3DVector;  //eƂ̕
begin
  inherited;

  hh:=Height / 2.0;
  hw:=Width / 2.0;
  hd:=Depth / 2.0;

  { ړ }
  iCtrl:=0;
  if Controller = ctPlayer2 then begin
    iCtrl:=1;
  end;

  if Controller in [ctCPU1,ctCPU2] then begin
    { ɁAAI͂܂ }
  end else begin
    { ͂ւ̉ }
    startPos:=Frame.GetTranslation(TheWorld);

    world_y:=Frame.WorldToLocalRot(Vector(0,1,0));
    world_z:=Frame.WorldToLocalRot(Vector(0,0,1));

    //c[hWYɐ
    if Sticks[iCtrl].X <> 0 then begin
      Frame.GetOrientation(TheWorld, oriZ,oriY);
      oriZ:=NowRotY(oriZ, Round(-Sticks[iCtrl].X * dt));
      oriY:=NowRotY(oriY, Round(-Sticks[iCtrl].X * dt));
      Frame.SetOrientation(TheWorld,oriZ,oriY);
    end;

    //Oi/ށc[hWYɑ΂Ă͓Ȃ
    if Sticks[iCtrl].Y <> 0 then begin
      fwdbwd:=Vector(0,0,-Sticks[iCtrl].Y*dt/100); //b10[g
      //[hWY菜ĐK
      fwdbwd:=NowScale(NowNormalize(NowSub(fwdbwd, NowScale(world_y, NowDotProduct(fwdbwd,world_y)))),dt/100);
      Frame.SetTranslation(Frame, fwdbwd);
    end;

    //bN(U)
    if (not PrevButtons[iCtrl,BTN_LOCKON]) and Buttons[iCtrl,BTN_LOCKON] and (not Locking) then begin
      Locking:=True;
      LockTransition:=0.0;
    end;
    if Locking then begin
      LockTransition:=LockTransition + dt / 500;
      if LockTransition > 1.0 then begin
        Locking:=False;
        LockTransition:=1.0;
      end;

      //LockTransitionWɂāǍ݂ƓG̈ʒuƂuh
      //UO̎pq1
      Frame.GetOrientation(TheWorld, oriZ,oriY);
      q1:=NowQuatFromOrientation(oriZ,oriY);

      //U̎pq2
      Frame.LookAt(opponent.Frame,Vector(0,0,0),TheWorld,0);
      Frame.GetOrientation(TheWorld, oriZ,oriY);
      q2:=NowQuatFromOrientation(oriZ,oriY);

      //uhĎpɃZbg
      q:=NowSlerpQuat(q1,q2, LockTransition);
      Frame.SetOrientationQuat(TheWorld, q);
    end;

    //ɗ
    Velocity:=NowAdd(Velocity,Vector(0, -0.5,0));

    //Wv(o[jA𐁂)
    //if Buttons[iCtrl,BTN_JUMP] and (not PrevButtons[iCtrl,BTN_JUMP]) And OnGround then begin
    if Buttons[iCtrl,BTN_JUMP] then begin
      Lift := 1.0;
    end else begin
      Lift:=Lift - 0.1;
      if Lift < 0 then
        Lift:=0;
    end;
    Velocity:=NowAdd(Velocity,Vector(0,Lift,0));


    Frame.SetTranslation(Frame, NowScale(world_y,Velocity.y * dt/1000));

    //ǃYŎۂɓ̈ʒuɕ␳
    endPos:=Frame.GetTranslation(TheWorld);
    bound.Center:=Vector(0,0,0);
    bound.Radii:=Vector(hw/2,hh*0.85,hd/2);
    TheMap.CollisionCheck(startPos,endPos,NowIdentityMatrix, bound, endPos);
    Frame.SetTranslation(TheWorld, endPos);

    //ǂł̍SvZɓ
    Velocity.Y:=NowSub(endPos,startPos).Y / dt * 1000;
    //CR(Y)
    Velocity.Y:=Velocity.y*0.90;


    //e1(ӂ)
    if Buttons[iCtrl,BTN_WEAPON1] then begin
      Frame.GetOrientation(TheWorld, oriZ,oriY);
      Owner.Add(TReimuTama1.Create(Owner, Now_T, endPos,
        NowRotX(NowRotY(oriZ,Random(50)-25),Random(50)-25), Self));
    end;

    //e2(A~bg)
    if Buttons[iCtrl,BTN_WEAPON2] and (not PrevButtons[iCtrl,BTN_WEAPON2]) then begin
      //E2Av4
      bulletDir:=Frame.LocalToWorldRot(NowRotX(NowRotY(Vector(0,0,1),512),512));
      Owner.Add(TReimuTama2.Create(Owner, Now_T, NowAdd(endPos,NowScale(bulletDir,1.0)), bulletDir, Self, True));

      bulletDir:=Frame.LocalToWorldRot(NowRotX(NowRotY(Vector(0,0,1),-512),512));
      Owner.Add(TReimuTama2.Create(Owner, Now_T, NowAdd(endPos,NowScale(bulletDir,1.0)), bulletDir, Self, True));

      bulletDir:=Frame.LocalToWorldRot(NowRotX(NowRotY(Vector(0,0,1),-256),512));
      Owner.Add(TReimuTama2.Create(Owner, Now_T, NowAdd(endPos,NowScale(bulletDir,1.0)), bulletDir, Self, True));

      bulletDir:=Frame.LocalToWorldRot(NowRotX(NowRotY(Vector(0,0,1),256),512));
      Owner.Add(TReimuTama2.Create(Owner, Now_T, NowAdd(endPos,NowScale(bulletDir,1.0)), bulletDir, Self, True));
    end;

    //e3(AzʃOl[h)
    


    {
    //ɂԂĂȂڒnĂƂ݂Ȃ
    //ǂ̗]ncȊÓAȂǂɏĂ鎞ɃWvłȂȂ
    idFloor:=TheMap.FindObject('n');
    OnGround:=False;
    //debugStr:=IntToStr(TheMap.CollidedObstaclesCount) + ' ';
    for i:=0 to TheMap.CollidedObstaclesCount-1 do begin
      //debugStr:=debugStr+TheMap.Objects[TheMap.TrianglesObjectIndex[TheMap.CollidedObstacles[i]]].name + ' ';
      if idFloor = TheMap.TrianglesObjectIndex[TheMap.CollidedObstacles[i]] then
        OnGround:=True;
    end;
    //if TheMap.CollidedObstaclesCount >= 2 then
    //  Application.MainForm.Caption:=debugStr;
    if OnGround then
      Velocity:=Vector(0,0,0);
    }

    //YWςĂȂȂڒnĂƂ݂Ȃ
    //ǂ̗]nAciWvłĂ܂
    {
    if Abs(startPos.y - endPos.y) < 0.01 then begin
      OnGround:=True;
      Velocity:=Vector(0,0,0);
    end else begin
      OnGround:=False;
    end;
    }
  end;


  { \ }
  nTouchSphere:=1;
  FTouchSphere[0].Center:=Frame.GetTranslation(TheWorld);
  FTouchSphere[0].Radius:=hw;

  //Aj[V
  iAnim:=Round(AgeT / 300) mod 4;
  if iAnim = 3 then
    iAnim := 1;

  //
  iDirection:=0;
  Frame.GetOrientation(TheCamera, oriZ, oriY);
  if (oriZ.z > -oriZ.X) And (oriZ.Z > oriZ.X) then
    iDirection:=0
  else if (oriZ.z > -oriZ.X) And (oriZ.Z < oriZ.X) then
    iDirection:=1
  else if (oriZ.Z < -oriZ.X) And (oriZ.Z < oriZ.X) then
    iDirection:=2
  else if (oriZ.z < -oriZ.X) And (oriZ.Z > oriZ.X) then
    iDirection:=3;


  Scene.PushBillboard(Frame,Vector(0,0,0),
  [
    SXVertexBB(-hw,-hh,$FFFFFFFF, iAnim * Texture.U/3,iDirection * Texture.V/4),
    SXVertexBB(+hw,-hh,$FFFFFFFF, (iAnim+1) * Texture.U/3,iDirection * Texture.V/4),
    SXVertexBB(-hw,+hh,$FFFFFFFF, iAnim * Texture.U/3.0,(iDirection+1) * Texture.V/4),
    SXVertexBB(+hw,+hh,$FFFFFFFF, (iAnim+1) * Texture.U/3,(iDirection+1) * Texture.V/4)
  ],
  Texture, sxbColorKey, True, False, False);

  //o[jA̕`
  if Lift > 0 then begin
    intencity:=Lift - Random*0.5;
    if intencity < 0 then
      intencity:=0;
    Scene.PushBillboardLite(Frame,Vector(0,-hh/2,-0.2),NowLerpColor($FFC06020,$FFFFFFFF,intencity), Lift+Random*0.1, CommonRes.FlareTexture, sxbAdd);
  end;

  //J̃Zbg
  //6[gA̓̈ʒu獘悤
  CameraFrame.SetTranslation(Frame, Vector(0,Height*1.5,-8));
  CameraFrame.LookAt(Frame, Vector(0,Height*0.3,0), Frame, 0);
  {
  CameraFrame.SetTranslation(Frame, Vector(0,Height/2,-1));
  CameraFrame.LookAt(Frame, Vector(0,Height/2,0), Frame, 0);
  CameraFrame.SetTranslation(Frame, Vector(0,Height/2,0));
  }
end;

procedure TReimu.OnCrush(target: TMover);
begin
  inherited;

end;

procedure TReimu.OnDamaged(target: TMover; dmg: Integer);
begin
  inherited;

end;


//݂e
{ TReimuTama1 }

constructor TReimuTama1.Create(AOwner:TMoverList; birthTime: Single; start, dir: D3DVector; AShooter:TReimu);
begin
  inherited Create(AOwner, birthTime);

  Shooter:=AShooter;
  Attr:=AttrMyBullet(Shooter.Controller);
  startPos:=start;
  direction:=dir;

  Frame:=TSXFrame.Create(TheWorld);
  Frame.Mesh:=Shooter.TamaMesh1;
  Frame.Texture:=Shooter.TamaTexture1;
  Frame.SetOrientation(Shooter.Frame, Vector(0,0,1),Vector(0,1,0));
  Frame.SetTranslation(TheWorld,StartPos);
  Frame.BlendMode:=sxbColorKey;
  Frame.Lighting:=True;
  //얲̑̂ɂĂ悤Ɍ̂h߁A1t[ڂ͕\Ȃ
  Frame.Visibility:=sxvHide;

  Frame.Material.Emissive.r:=0.5;
  Frame.Material.Emissive.g:=0.5;
  Frame.Material.Emissive.b:=0.5;
  Frame.Material.Emissive.a:=0.5;
  Frame.Material.Diffuse.a:=1.0;
  Frame.Material.Diffuse.g:=1.0;
  Frame.Material.Diffuse.b:=1.0;
  Frame.Material.Diffuse.r:=1.0;
  Frame.Material.Specular.a:=0;
  Frame.Material.Specular.g:=0;
  Frame.Material.Specular.b:=0;
  Frame.Material.Specular.r:=0;
  Frame.Material.Ambient.a:=0.5;
  Frame.Material.Ambient.r:=0.5;
  Frame.Material.Ambient.g:=0.5;
  Frame.Material.Ambient.b:=0.5;

  Frame.MeshMatrix:=NowScaleMatrix(2,2,2);



  DropMode:=False;
  nTouchSphere:=1;
  FTouchSphere[0].Radius:=0.08;
end;

//î
destructor TReimuTama1.Destroy;
begin
  Frame.Free;
  inherited;
end;

procedure TReimuTama1.Move(dt: Single);
var
  pos,endpos:D3DVector;
  bound:TEllipsoid3D;
  q:TQuaternion;
  mtrx:D3DMATRIX;
  oriZ,oriY:D3DVector;
begin
  inherited;

  //얲̑̂ɂĂ悤Ɍ̂h߁A1t[ڂ͕\Ȃ
  if Tick >= 1 then
    Frame.Visibility:=sxvShow;

  //b30mŔ
  if not DropMode then begin
    pos:=Frame.GetTranslation(TheWorld);
    endpos:= NowAdd(startPos, NowScale(direction, AgeT/1000 * 30));

    //ǂɓĂȂ
    bound.Center:=Vector(0,0,0);
    bound.Radii:=Vector(0.04,0.04,0.08);
    if TheMap.CollisionCheckOnce(pos,endpos,Frame.WorldMatrix, bound, endpos) then begin
      //ԂAhbv[hɈڍsA蔻
      DropMode:=True;
      StartPos:=endpos;
      HitT:=AgeT;
      //ˌ̑xxNgvZ
      Direction:=NowReflection(Direction, TheMap.Triangles[TheMap.CollidedObstacles[0]].Normal);
      Direction:=NowRotY(Direction, Random(2000)-1000);
      Direction:=NowRotX(Direction, Random(2000)-100);
      Frame.GetOrientation(TheWorld, oriZ,oriY);
      Frame.SetOrientation(TheWorld,Direction,oriY);
      DropAxis:=NowNormalize(Vector(Random-0.5,Random-0.5,Random-0.5));

      Attr:=maThru;
    end;
    Frame.SetTranslation(TheWorld, endpos);
    FTouchSphere[0].Center:=pos;
  end else begin
    //[hcd͂ɂėȂXs
    pos:=Frame.GetTranslation(TheWorld);
    pos:= NowAdd(StartPos, NowScale(Direction, (AgeT-HitT)/1000 * 3));
    pos:= NowAdd(pos, Vector(0,-0.000003*(AgeT-HitT)*(AgeT-HitT),0));
    q:=NowQuatFromRotation(DropAxis, Round(dt*20)); //5Hz炢̉]
    mtrx:=NowMatrixFromQuat(q);
    Frame.GetOrientation(TheWorld, oriZ,oriY);
    oriZ:=NowTransform(oriZ,mtrx);
    oriY:=NowTransform(oriY,mtrx);
    Frame.SetOrientation(TheWorld, oriZ,oriY);

    Frame.SetTranslation(TheWorld, pos);
  end;


  //c0.5b؂ƁAĂe͂ƂȂc͂Ȃ񂾂
  if (AgeT > 500) And (DropMode) then begin
    Frame.BlendMode:=sxbAlpha;
    Frame.Material.Diffuse.a:=(1000-AgeT) / 500;
    Frame.Material.Ambient.a:=0;
    Frame.Material.Specular.a:=0;
    Frame.Material.Emissive.a:=0;
  end;

  //ˌA1bŏ
  if AgeT > 1000 then
    Die;
end;



{ TReimuTama2 }

constructor TReimuTama2.Create(AOwner: TMoverList; birthTime: Single;
  start, dir: D3DVector; AShooter: TReimu; clockwise:Boolean);
begin
  inherited Create(AOwner, birthTime);

  Shooter:=AShooter;
  Attr:=AttrMyBullet(Shooter.Controller);

  Position:=start;
  Velocity:=NowScale(dir,50); //50m/sec
  ClockWiseRotation:=clockwise;
  Theta:=0;

  Frame:=TSXFrame.Create(TheWorld);
  Frame.Texture:=Shooter.TamaTexture2;
  Frame.SetOrientation(Shooter.Frame, Vector(0,0,1),Vector(0,1,0));
  Frame.SetTranslation(TheWorld,Position);
  Frame.BlendMode:=sxbColorKey;

  nTouchSphere:=1;
  FTouchSphere[0].Radius:=1.0;
  Trailer:=TVaporTrail.Create(
    AOwner, birthTime, Self, 500, 15, Nil, sxbAlpha,
    $40FFFFFF, $00FFFFFF, $40FF0000, $00FF0000);
  Owner.Add(Trailer);
end;

destructor TReimuTama2.Destroy;
begin
  Frame.Free;

  inherited;
end;

procedure TReimuTama2.Move(dt: Single);
var
  targetPos:D3DVector;
  delta:D3DVector;  //GƂ̋
  endPos:D3DVector;
  bound:TEllipsoid3D;
  vBBs:Array [0..3] of TSXVertexBB;
  oriZ,oriY,oriX:D3DVector;
begin
  inherited Move(dt);

  //ړcĜقɌB
  if AgeT <= 500 then begin
    targetPos:=Shooter.opponent.Frame.GetTranslation(TheWorld);
    delta:=NowSub(targetPos,Position);
    //ʂɓG𑨂ĂȂƃz[~OȂ
    if NowDotProduct(delta,Velocity) > 0 then
      Velocity:=NowAdd(NowScale(Velocity,0.8) , NowScale(NowNormalize(delta),0.5))
    else
      Velocity:=NowScale(Velocity,0.8);

    endPos:=NowAdd(Position, NowScale(Velocity, dt/1000));
    Inc(Theta,Round(NowLength(Velocity))*20);
  end else begin
    //50mbŒi
    Inc(Theta,250);
    Velocity:=NowScale(NowNormalize(Velocity),50);
    endPos:=NowAdd(Position, NowScale(Velocity, dt/1000));
  end;

  //QɂԂ
  bound.Center:=Vector(0,0,0);
  bound.Radii:=Vector(1.0,1.0,1.0);
  if TheMap.CollisionCheckOnce(Position,endPos, Frame.GetTransform(TheWorld), bound, endPos) then begin
    //GtFNguāAI
    Owner.Add(TSimpleExplode.Create(Owner,Now_T, 500, endPos, 1.0, $FFFF4040, sxbAdd, esSpread));
    Die;
  end;

  Frame.SetTranslation(TheWorld,endPos);
  Position:=endPos;

  //\
  if ClockWiseRotation then
    RotateBB(1.0,1.0, Round(Theta), $FFFFFFFF, 0,0,Shooter.TamaTexture2.U, Shooter.TamaTexture2.V, vBBs)
  else
    RotateBB(1.0,1.0, Round(-Theta), $FFFFFFFF, 0,0,Shooter.TamaTexture2.U, Shooter.TamaTexture2.V, vBBs);

  Scene.PushBillboard(Frame,Vector(0,0,0), vBBs, Shooter.TamaTexture2, sxbColorKey,
    True,True,False);

  //OՕ\p(ǂ̗]n)
  Shooter.Frame.GetOrientation(TheWorld,oriZ,oriY);
  oriX:=NowCrossProduct(NowNormalize(Velocity),oriY);
  PositionTrailed[0]:=NowAdd(Position,NowScale(NowAdd(NowScale(oriX,vBBs[0].dx),NowScale(oriY,vBBs[0].dy)), 0.5));
  PositionTrailed[1]:=NowAdd(Position,NowScale(NowAdd(NowScale(oriX,vBBs[2].dx),NowScale(oriY,vBBs[2].dy)), 0.5));

  if not Trailer.Trailing then
    Trailer.StartTrail;

  //2.5bŎ
  if AgeT > 2500 then
    Die;
end;

end.
