unit Title;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ddsd, Ddidex, DGCarad9, s_mathpack, SXLib9,d3d9, AppEvnts,
  octettree, defs, util;

type

TTitle = class
  private
    logo:TDGTexture;
  public
    constructor Create;
    destructor Destroy; override;
    procedure Move(dt:Single);
end;


implementation

{ TTitle }

constructor TTitle.Create;
begin
  logo:=TDGTexture.Create(DG,DGFMT_ARGB,0,D3DPOOL_MANAGED,0,'S');
  logo.LoadFromFile(PATH + 'g\logo.bmp');
end;

destructor TTitle.Destroy;
begin
  logo.Free;

  inherited;
end;

procedure TTitle.Move(dt: Single);
var
  prevBtn:Boolean;
begin
  Scene.PushSpriteLite(
    Vector2D((ScreenWidth - logo.Width) div 2,160),
    NowHSBToRGB((Now_T mod 8000)/8000.0, 0.5,1.0),
    logo, sxbAdd, False);

  //OK{^ꂽAQ[Jn
  prevBtn:=Joy.Buttons[BTN_OK];
  Joy.OrScan([DI_KEYB,DI_JOY1]);
  if Joy.Buttons[BTN_OK] and (not prevBtn) then begin
    GameState:=gsGame;
  end;
end;

end.
