unit commonObj;

//ږIuWFNg

//eNX`i[ɂƂAėpGtFNg

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ddsd, Ddidex, DGCarad9, s_mathpack, SXLib9,d3d9, AppEvnts,
  octettree, defs, game, util;

type
//X^C
TExplodeStyle = (esSpread, esShrink, esConstant);
    //ʃeNX`EbVEʉƂ̊i[
//DLR[hǁAꂪȒPEł̂c
TResourceContainer = class
  protected
    Resources:TList;
  public
    FlareTexture:TDGTexture;
    WindTexture:TDGTexture;
    constructor Create;
    destructor Destroy; override;
end;

//V{
TSimpleExplode = class(TMover)
  private
    FLastingTime:Single;
    FColor:D3DCOLOR;
    FBlendMode:TSXBlendMode;
    FTexture:TDGTexture;
    FSize:Single;
    FPosition:D3Dvector;
    FStyle:TExplodeStyle;
  public
    constructor Create(AOwner:TMoverList; birthTime:Single; lastingTime:Single; Position:D3DVector;
      size:Single; color:D3DCOLOR = $FFFFFFFF; blendMode:TSXBlendMode=sxbAdd; style:TExplodeStyle=esSpread;
      texture:TDGTexture = Nil);
    procedure Move(dt:Single); override;
end;

TVaporTrail = class;

//OՂ邱Ƃ̏o镨́ATrailerCreateȂ̂ŁAgCreateĂ
TTrailee = class(TMover)
  private
  protected
    PositionTrailed:Array[0..1] of D3DVector; //OՂ̂ʒu
    Trailer:TVaporTrail;      //O
  public
    constructor Create(AOwner:TMoverList; birthTime:Single);
    procedure Die; override;
end;

//O
//traileeɎw肵TMoverǂOՂ`
TVaporTrail = class(TMover)
  private
    FTrailee:TTrailee;          //Nǂ邩
    FLastingTime:Single;      //cǐՌłA̎ԂŊS
    FSamplingInterval:Single; //TvOԊu
    FTexture:TDGTexture;
    FBlendMode:TSXBlendMode;

    FTrail:Array[0..1] of Array of D3DVector;//֐(֐ߓ_ƉE֐ߓ_)
    FTrailCount:Integer;      //֐ߐc(FLastingTime / FSamplingInterval) + 1

    PrevSampled:Single;       //OTvO
    SamplingCount:Integer;    //TvO

    LVs:Array of D3DLVertex; //TrailD3D̒_ŕ\

    FTraileeIsAlive:Boolean;  //ǐՂ镨̂͂܂Ă
    Frame:TSXFrame;
    FTraileeDeadT:Single;     //ǐՑΏۂ񂾎
    FStartTrail:Boolean;      //ǐՊJn

    FStartColor1,FEndColor1,FStartColor2,FEndColor2:D3DColor;
    procedure OnRender(Sender:TSXFrame; Scene:TSXScene; DG:TDGCarad);
    procedure OnQueryZ(Sender:TSXFrame; Scene:TSXScene; DG:TDGCarad; var ZValue:Single);
    procedure OnQueryVisibility(Sender:TSXFrame; Scene:TSXScene; DG:TDGCarad; var Visibility:TSXVisibility);
    procedure Sampling;

  public
    constructor Create(AOwner:TMoverList; birthTime:Single; trailee:TTrailee; lastingTime:Single;
      samplingInterval:Single; texture:TDGTexture = Nil; blendMode:TSXBlendMode = sxbAlpha;
      startColor1:D3DCOLOR = $FFFFFFFF; endColor1:D3DCOLOR = $00FFFFFF;
      startColor2:D3DCOLOR = $FFFFFFFF; endColor2:D3DCOLOR = $00FFFFFF);
    destructor Destroy; override;
    procedure Move(dt:Single); override;
    procedure StartTrail;
    property Trailing:Boolean read FStartTrail;
end;



var
  CommonRes:TResourceContainer;

implementation

{ TResourceContainer }

constructor TResourceContainer.Create;
begin
  Resources:=TList.Create;

  FlareTexture:=TDGTexture.Create(DG, DGFMT_ARGB);
  FlareTexture.LoadFromFile(PATH+'g\flare.bmp');
  Resources.Add(FlareTexture);

  WindTexture:=TDGTexture.Create(DG, DGFMT_ARGB);
  WindTexture.LoadFromFile(PATH+'g\wind.bmp');
  Resources.Add(WindTexture);
end;

destructor TResourceContainer.Destroy;
var
  i:Integer;
begin
  For i:=0 to Resources.Count-1 do
    TObject(Resources.Items[i]).Free;

  Resources.Free;
  inherited;
end;



{ TSimpleExplode }

constructor TSimpleExplode.Create(AOwner: TMoverList; birthTime,
  lastingTime:Single; Position:D3DVector; size: Single; color: D3DCOLOR; blendMode: TSXBlendMode;
  style:TExplodeStyle; texture: TDGTexture);
begin
  inherited Create(AOwner, birthTime);

  Attr:=maThru;

  FLastingTime:=lastingTime;
  FSize:=size;
  FColor:=color;
  FBlendMode:=blendMode;
  FTexture:=texture;
  if texture = Nil then
    FTexture:=CommonRes.FlareTexture;
  FPosition:=Position;
  FStyle:=style;
end;

procedure TSimpleExplode.Move(dt: Single);
var
  size:Single;
  color:D3DColor;
begin
  inherited Move(dt);

  if FLastingTime <= AgeT then begin
    Die;
    exit;
  end;

  if FBlendMode = sxbAdd then begin
    Color:=NowLerpColor(FColor,$FF000000, AgeT/FLastingTime);
  end else begin
    Color:=NowLerpColor(FColor and $00FFFFFF,FColor, AgeT/FLastingTime);
  end;

  size:=FSize;
  Case FStyle of
    esSpread: size:=FSize * (1 + AgeT/FLastingTime);
    esShrink: size:=FSize * (1 - (AgeT/FLastingTime)*0.5);
  end;

  Scene.PushBillboardLite(TheWorld, FPosition,color,size,FTexture,FBlendMode);
end;

{ TTrailee }

constructor TTrailee.Create(AOwner: TMoverList; birthTime: Single);
begin
  inherited Create(AOwner, birthTime);
  Trailer:=Nil;
end;

procedure TTrailee.Die;
begin
  inherited Die ;
  //ʎ́AOՃIuWFNgɎɗl`
  if Assigned(Trailer) then begin
    Trailer.FTraileeIsAlive:=False;
    Trailer.FTraileeDeadT:=Now_T;
  end;
end;

{ TVaporTrail }

constructor TVaporTrail.Create(AOwner:TMoverList; birthTime:Single;
  trailee:TTrailee; lastingTime:Single; samplingInterval:Single;
  texture:TDGTexture = Nil; blendMode:TSXBlendMode = sxbAlpha;
  startColor1:D3DCOLOR = $FFFFFFFF; endColor1:D3DCOLOR = $00FFFFFF;
  startColor2:D3DCOLOR = $FFFFFFFF; endColor2:D3DCOLOR = $00FFFFFF);
begin
  inherited Create(AOwner, birthTime);

  Attr:=maThru;

  FTrailee:=trailee;
  FLastingTime:=lastingTime;
  FSamplingInterval:=samplingInterval;
  FTexture:=texture;
  if texture = nil then
    FTexture:=CommonRes.WindTexture;

  FBlendMode:=blendMode;
  FTraileeIsAlive:=True;

  FTrailCount:=Round(FLastingTime / FSamplingInterval) + 1;
  SetLength(FTrail[0], FTrailCount);
  SetLength(FTrail[1], FTrailCount);
  SetLength(LVs,FTrailCount * 2);

  FStartColor1:=startColor1;
  FStartColor2:=startColor2;
  FEndColor1:=endColor1;
  FEndColor2:=endColor2;


  SamplingCount:=0;
  FStartTrail:=False;

  Frame:=TSXFrame.Create(TheWorld);
  Frame.OnRender:=OnRender;
  Frame.OnQueryZ:=OnQueryZ;
  Frame.OnQueryVisibility:=OnQueryVisibility;
end;

destructor TVaporTrail.Destroy;
begin
  Frame.Free;
  FTrail[0]:=Nil;
  FTrail[1]:=Nil;
  LVs:=Nil;
  inherited;
end;

procedure TVaporTrail.Move(dt: Single);
begin
  inherited Move(dt);

  Sampling;
  if (not FTraileeIsAlive) and (Now_T > FLastingTime + FTraileeDeadT) then
    //ΏۂłLastingToȂA
    Die;
end;

//`
procedure TVaporTrail.OnRender(Sender: TSXFrame; Scene: TSXScene;
  DG: TDGCarad);
var
  i:Integer;
  color:D3DColor;
  tmpLV:D3DLVertex;
begin
  //тxɃTvOĂȂƃC
  if SamplingCount < 2 then
    exit;

  Scene.StateRestorer.Memory;
  Scene.StateRestorer.SetRS(D3DRS_ZWRITEENABLE, Cardinal(False));
  Scene.StateRestorer.SetRS(D3DRS_COLORVERTEX, Cardinal(True));
  Scene.StateRestorer.SetRS(D3DRS_ALPHATESTENABLE,Cardinal(False));
  Scene.StateRestorer.SetRS(D3DRS_LIGHTING, Cardinal(False));
  //Scene.StateRestorer.SetRS(D3DRS_SEPARATEALPHABLENDENABLE, Cardinal(True));
  Scene.StateRestorer.SetRS(D3DRS_ALPHABLENDENABLE, Cardinal(True));

  //uh[h͈ȉ̎lނT|[gȂƂɂƂ
  Case FBlendMode of
    sxbAlpha : begin
      Scene.StateRestorer.SetRS(D3DRS_SRCBLEND, Cardinal(D3DBLEND_SRCALPHA));
      Scene.StateRestorer.SetRS(D3DRS_DESTBLEND, Cardinal(D3DBLEND_INVSRCALPHA));
    end;
    sxbAdd: begin
      Scene.StateRestorer.SetRS(D3DRS_SRCBLEND, Cardinal(D3DBLEND_ONE));
      Scene.StateRestorer.SetRS(D3DRS_DESTBLEND, Cardinal(D3DBLEND_ONE));
    end;
    sxbMulNeg: begin
      Scene.StateRestorer.SetRS(D3DRS_SRCBLEND, Cardinal(D3DBLEND_ZERO));
      Scene.StateRestorer.SetRS(D3DRS_DESTBLEND, Cardinal(D3DBLEND_INVSRCCOLOR));
    end;
    sxbMul: begin
      Scene.StateRestorer.SetRS(D3DRS_SRCBLEND, Cardinal(D3DBLEND_ZERO));
      Scene.StateRestorer.SetRS(D3DRS_DESTBLEND, Cardinal(D3DBLEND_SRCCOLOR));
    end;
  end;
  
  //
  for i:=0 to SamplingCount-2 do begin
    color:=NowLerpColor(FStartColor1, FEndColor1, (i / (SamplingCount-1)));
    LVs[i*2].x:=FTrail[0,i].x;
    LVs[i*2].y:=FTrail[0,i].y;
    LVs[i*2].z:=FTrail[0,i].z;
    LVs[i*2].color:=color;
    LVs[i*2].specular:=0;
    LVs[i*2].tu:=0;
    LVs[i*2].tv:=i / (SamplingCount-1);

    LVs[i*2+1].x:=FTrail[1,i].x;
    LVs[i*2+1].y:=FTrail[1,i].y;
    LVs[i*2+1].z:=FTrail[1,i].z;
    LVs[i*2+1].color:=color;
    LVs[i*2+1].specular:=0;
    LVs[i*2+1].tu:=1;
    LVs[i*2+1].tv:=i / (SamplingCount-1);

    //DGCarad_PutDebugMessage(Format('Trail #%d ... %.8x',[i,DWord(color)]));
    {
    DGCarad_PutDebugMessage(Format('Trail #%d ... (%f,%f,%f), (%f,%f,%f)',[
      i,FTrail[0,i].x,FTrail[0,i].y,FTrail[0,i].z,
      FTrail[1,i].x,FTrail[1,i].y,FTrail[1,i].z]));
    }

  end;

  if FTexture = Nil then
    DG.D3DDevice.SetTexture(0, Nil)
  else
    DG.D3DDevice.SetTexture(0, FTexture.Texture);

  DG.D3DDevice.SetFVF(D3DFVF_LVERTEX);
  DG.D3DDevice.DrawPrimitiveUP(D3DPT_TRIANGLESTRIP, (SamplingCount-2)*2, @LVs[0], Sizeof(D3DLVERTEX));

  //
  for i:=0 to SamplingCount-1 do begin
    color:=NowLerpColor(FStartColor2, FEndColor2, (i / (SamplingCount-1)));
    tmpLV:=LVs[i*2];
    LVs[i*2]:=LVs[i*2+1];
    LVs[i*2+1]:=tmpLV;
    LVs[i*2].color:=color;
    LVs[i*2+1].color:=color;
  end;
  DG.D3DDevice.DrawPrimitiveUP(D3DPT_TRIANGLESTRIP, (SamplingCount-2)*2, @LVs[0], Sizeof(D3DLVERTEX));

  Scene.StateRestorer.Restore;
end;

//
procedure TVaporTrail.OnQueryVisibility(Sender: TSXFrame; Scene: TSXScene;
  DG: TDGCarad; var Visibility: TSXVisibility);
begin
  Visibility:=sxvShow;
end;

//ZlԂ
procedure TVaporTrail.OnQueryZ(Sender: TSXFrame; Scene: TSXScene;
  DG: TDGCarad; var ZValue: Single);
begin
  ZValue:=1.0;
end;

procedure TVaporTrail.Sampling;
var
  i:Integer;
begin
  //TvOԊu߂܂ł̓TvOȂ
  if PrevSampled + FSamplingInterval > Now_T then
    exit;

  //ǐՊJn߂oĂȂATvOȂ
  if not FStartTrail then
    exit;

  //K㑗肷
  For i:=SamplingCount-1 downto 1 do begin
    FTrail[0,i]:=FTrail[0,i-1];
    FTrail[1,i]:=FTrail[1,i-1];
  end;

  //ǉ
  if FTraileeIsAlive then begin
    FTrail[0,0]:=FTrailee.PositionTrailed[0];
    FTrail[1,0]:=FTrailee.PositionTrailed[1];
  end else begin
    //ΏۂłȂAK𑗂̂
    //FTrail[0,0]:=FTrail[0,1];
    //FTrail[1,0]:=FTrail[1,1];
    ;
  end;

  Inc(SamplingCount);
  if SamplingCount >  FTrailCount then
    SamplingCount := FTrailCount;
  PrevSampled:=Now_T;
end;

procedure TVaporTrail.StartTrail;
begin
  FStartTrail:=True;
  SamplingCount:=1;
  FTrail[0,0]:=FTrailee.PositionTrailed[0];
  FTrail[1,0]:=FTrailee.PositionTrailed[1];
end;

end.
