unit mukiSTGMain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ddsd, Ddidex, DGCarad9, s_mathpack, SXLib9,d3d9, AppEvnts,
  octettree, Title, Game, defs, mmsystem;

type
  TSTGForm = class(TForm)
    DGCarad: TDGCarad;
    Joy_: TDDIDEX;
    Sound_: TDDSD;
    ApplicationEvents1: TApplicationEvents;
    procedure FormCreate(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure ApplicationEvents1Idle(Sender: TObject; var Done: Boolean);
  private
    { Private 錾 }
    Title:TTitle;
    Game:TGame;
    PrevGameState:TGameState;
  public
    { Public 錾 }
  end;

var
  STGForm: TSTGForm;

implementation

{$R *.dfm}

//͂܂͂܂
procedure TSTGForm.FormCreate(Sender: TObject);
begin
  //O[oϐ̏
  DG:=DGCarad;
  PATH:=ExtractFilePath(Application.ExeName);
  Joy:=Joy_;
  Sound:=Sound_;

  //
  ClientWidth:=640;
  ClientHeight:=480;
  ScreenWidth:=ClientWidth;
  ScreenHeight:=ClientHeight;
  timeBeginPeriod(1);

  //𑜓xƃfvXXeVT[tFX̐ݒ
  DG.WindowMode(ClientWidth, ClientHeight, DGFMT_ZDetail);

  Scene:=TSXScene.Create(DG);
  Scene.SetProjection(Pi/4, ClientHeight/ClientWidth, 0.1, 1000.0);
  Scene.SetViewport(0,0,ClientWidth,ClientHeight);

  Title:=TTitle.Create;
  Game:=TGame.Create;

  //^Cg
  PrevGameState:=gsTitle;
  GameState:=gsTitle;
end;

//[Ȃ
procedure TSTGForm.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  Title.Free;
  Game.Free;
  Scene.Free;

  timeEndPeriod(1);
end;


//C[v
procedure TSTGForm.ApplicationEvents1Idle(Sender: TObject;
  var Done: Boolean);
var
  prev_T:Integer;
begin
  prev_T:=Now_T;
  Now_T:=timeGetTime;


  //Direct3DfoCXĂ邩eXgĂ`
  Case DWord(DG.D3DDevice.TestCooperativeLevel) of
    //OKAĂ܂
    D3D_OK: begin
      //Q[Xe[gŗL
      if PrevGameState <> GameState then begin
        if PrevGameState = gsTitle then
          Game.GameStart;
        if PrevGameState = gsGame then
          Game.GameOver;
      end;
      PrevGameState:=GameState;

      Case GameState of
        gsTitle: Title.Move(Now_T - prev_T);
        gsGame: Game.Move(Now_T - prev_T);
      end;

      //V[̕`
      DG.D3DDevice.BeginScene;

      Scene.Clear(D3DCLEAR_TARGET + D3DCLEAR_ZBUFFER, $FF000000, 1.0, 0);
      Scene.Render(TheWorld);

      DG.D3DDevice.EndScene;

      DG.D3DDevice.Present(Nil,Nil,0,Nil);
    end;

    //foCX͐Ă邯ǁAXgŃZbgĂȂ
    D3DERR_DEVICENOTRESET: begin
      DG.Reset;
    end;
  end;

  //ݒ肷ƁÃCxgsȂĂ܂̃CxgĂ΂
  Done:=False;
end;

end.
