unit fighter;

//Ȃɂ키̂ƁAʃIuWFNg
interface
uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ddsd, Ddidex, DGCarad9, s_mathpack, SXLib9,d3d9, AppEvnts,
  octettree, Game, defs, util;


type

//삵ĂlAm̃^Cv
TControllerType = (ctPlayer1, ctPlayer2, ctCPU1, ctCPU2);



//@ɂē̂̊NX
//}bvɂ銱ȂǂIɌvZĂ
TPhysMover = class(TMover)
  protected
    Bound:TEllipsoid3D; //}bvƂ̓蔻ɗp鋫E
    Mass:Single;        //
    Velocity:D3DVector; //x
    Position:D3DVector; //ʒu
    Friction:Single;    //CWc RNɑ΂C0.85x
    Drag:Single;        //CRWc qg0.6*Oʓeʐ x
    Gravity:D3DVector;  //d͌W
    OnGround:Boolean;   //ڒnĂtO
  public
    constructor Create(AOwner:TMoverList; birthTime:Single; AMass:Single; ABound:TEllipsoid3D; AFriction:Single; ADrag:Single; AGravity:D3Dvector);
    procedure Move(dt:Single); override;
    procedure AddImpact(impact:D3DVector);  //Ռ(͐)
end;

//키̂̊NX
TFighter = class(TPhysMover)
  private
    FCameraFrame:TSXFrame;
    MyFrame:TSXFrame;            //̃t[
  protected
    Controller:TControllerType;  //N삵Ă邩
  public
    opponent:TFighter;  //
    constructor Create(AOwner:TMoverList; birthTime:Single; AController:TControllerType;
      AMass:Single; ABound:TEllipsoid3D; AFriction:Single; ADrag:Single; AGravity:D3DVector);
    destructor Destroy; override;
    procedure Die; override;
    procedure Move(dt:Single); override;
    function CheckTouch(Target:TMover):Boolean; override; //蔻
    procedure OnCrush(target:TMover); override;
    procedure OnDamaged(target:TMover; dmg:Integer); override;
    procedure CatchMessage(from:TMover; info1,info2:Integer; xInfo:Pointer); override;
    property CameraFrame:TSXFrame read FCameraFrame;  //J
    property Frame:TSXframe read MyFrame;
end;


//ϊ
function AttrMyself(iam:TControllerType):TMoverAttr;
function AttrMyBullet(iam:TControllerType):TMoverAttr;

implementation


//ϊ
function AttrMyself(iam:TControllerType):TMoverAttr;
begin
  if iam = ctPlayer1 then
    result:=maPlayer1
  else
    result:=maPlayer2
end;

function AttrMyBullet(iam:TControllerType):TMoverAttr;
begin
  if iam = ctPlayer1 then
    result:=maPlayer1Bullet
  else
    result:=maPlayer2Bullet;
end;



{ TFighter }

constructor TFighter.Create(AOwner:TMoverList; birthTime:Single; AController:TControllerType;
  AMass:Single; ABound:TEllipsoid3D; AFriction:Single; ADrag:Single; AGravity:D3DVector);
begin
  inherited Create(AOwner, birthTime, AMass, ABound, AFriction, ADrag, AGravity);
  Controller:=AController;
  MyFrame:=TSXFrame.Create(TheWorld);
  FCameraFrame:=TSXFrame.Create(TheWorld);
end;

destructor TFighter.Destroy;
begin
  MyFrame.Free;
  FCameraFrame.Free;

  inherited;
end;

procedure TFighter.CatchMessage(from: TMover; info1, info2: Integer;
  xInfo: Pointer);
begin
  inherited;

end;

function TFighter.CheckTouch(Target: TMover): Boolean;
begin
  result:=inherited CheckTouch(Target);
end;


procedure TFighter.Die;
begin
  inherited;

end;

procedure TFighter.Move(dt: Single);
begin
  inherited;

end;

procedure TFighter.OnCrush(target: TMover);
begin
  inherited;

end;

procedure TFighter.OnDamaged(target: TMover; dmg: Integer);
begin
  inherited;

end;

{ TPhysMover }

constructor TPhysMover.Create(AOwner: TMoverList; birthTime, AMass: Single;
  ABound: TEllipsoid3D; AFriction: Single; ADrag:Single; AGravity:D3DVector);
begin
  inherited Create(AOwner, birthTime);
  Mass:=AMass;
  Bound:=ABound;
  Friction:=AFriction;
  Gravity:=AGravity;
  Drag:=ADrag;
  Velocity:=Vector(0,0,0);
  Position:=Vector(0,0,0);
  OnGround:=False;
end;

procedure TPhysMover.AddImpact(impact: D3DVector);
begin
  Velocity:=NowAdd(Velocity, NowScale(impact, 1/Mass));
end;

procedure TPhysMover.Move(dt: Single);
var
  startPos,endPos,resultPos:D3DVector;
  kickback:D3DVector;
  verticalF:Single;
  moveDir:D3DVector;
begin
  inherited;

  startPos:=Position;
  Velocity:=NowAdd(Velocity, NowScale(Gravity,dt/1000));
  endPos:=NowAdd(Position, NowScale(Velocity,dt/1000));

  TheMap.CollisionCheck(startPos,endPos,NowIdentityMatrix, Bound, resultPos);

  //̌vZ
  moveDir:=NowSub(endPos,startPos);
  kickback:=NowSub(resultPos, endPos);
  OnGround := kickback.y > 1.0E-6; //Yւ̃LbNobN΁AuڒnĂv

  if NowLength(moveDir) < 1.0E-6 then begin
    //ĂȂcC͍lȂ
    ;
  end else begin
    moveDir:=NowNormalize(moveDir);
    //R͂̌vZ
    //Mass * kickback /(dt*dt)cꂪR

    //R͂̑傫̖CW{AƋtɂ
    //傫́AMass * kickback / (dt*dt) * Friction
    //̗͂ǂꂾ̑x^邩ƂƁA
    // R / Mass *dt Ȃ̂ŁA
    // kickback / dt * Friction ŋ܂B
    verticalF:=NowLength(kickback) / (dt/1000) * Friction;

    Velocity:=NowAdd(Velocity,NowScale(moveDir, -verticalF));
  end;

  //CR
  //Velocity * RW[kg/s]
  Velocity:=NowSub(Velocity, NowScale(Velocity, Drag / Mass * (dt/1000)));

  //ǂł̍SvZɓ
  {
  Velocity.Y:=NowSub(endPos,startPos).Y / dt * 1000;
  //CR(Y)
  Velocity.Y:=Velocity.y*0.90;
  }

  Position:=resultPos;
end;

end.
