unit Octettree;

//MQOt@C
//
//
//  MMIV (c)SANDMAN presents!!


interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, DGCarad9, d3d9, s_mathpack,
  QDArc, SXLib9, math, uMQO2SX;//,s_3DNow;


const
  OCTREE_MAX_COLLIDE = 5; //̕ǃYœ蔻s

type

TOctreeIndexList = class;
TOctree = class;

TOctreeNodeIndex = Cardinal;



//Octreem[hA1m[hɊ܂܂̊Ǘ
// ̎ĂOp`Ԃ̎Op`Ä̗͂ǂǂ܂łǗ
//Op`͌ł́AQXgƂĂ̂݋@\B
//`Ɋւ͎ȂB
TOctreeNode = class
  private
    FOwner:TOctree;
    FTriangleIndices:TOctreeIndexList;            //QXg
    FGridSize:Single;  //ӂ̃TCY
    FChildren:Array[0..7] of TOctreeNode;   //qm[h
    FBounds:TBox3D;    //m[hɊOڂ闧
    FCenter:D3DVECTOR;  //m[h̒S
    function GetChildren(idx: TOctreeNodeIndex): TOctreeNode;
    function GetTriangles(idx:integer): TFacedTriangle3D;
    function GetTrianglesCount: Integer;
  protected
    procedure Divide(newGridSize:Single; const newCenter:D3DVECTOR; level:Integer; margin:Single); //Tum[hɕA񐔂level
  public
    constructor Create(AOwner:TOctree);
    destructor Destroy; override;
    //̃m[hLĂOp`̔ԍ
    property TriangleIndices:TOctreeIndexList read FTriangleIndices;
    property Triangles[idx:Integer]:TFacedTriangle3D read GetTriangles; //TrianglesIndices[i]QƂ
    property GridSize:Single read FGridSize;
    property Owner:TOctree read FOwner;
    property Children[idx:TOctreeNodeIndex]:TOctreeNode read GetChildren; //qm[h
    property Bounds:TBox3D read FBounds;    //̐߂͈
    property Center:D3DVECTOR read FCenter; //S
    property TrianglesCount:Integer read GetTrianglesCount;
end;

//Փˌop
TCollisionInfo = record
  Fraction:Single;            //g[Xc0start, 1end 0.5͒Ԓn_
  Stopped:D3DVECTOR;          //ǂłƂ܂
  CollisionNormal:D3DVECTOR;  //Փ˂ʂ̖@
  WallIndex:Integer;          //Ԃǂ̔ԍ
end;


//octet-treeNX
// Փˌop̃|SQAu镨́vp̃bV{eNX`{}eȂg
// ȂǂǗ
TOctree = class
  private
    DG:TDGCarad;  //FXʓ|Ă炤ɂȂDGCaradIuWFNg
    FNodeCount:Integer;
    FTriangles:Array of TFacedTriangle3D;       //ՓˌopOp`
    FTrianglesMaterialIndex:Array of Integer;   //^ZRCÃt@CɊi[Ăۂ́A}eAԍ
    FTrianglesObjectIndex:Array of Integer;     //^ZRCÃt@CɊi[Ăۂ́AIuWFNgԍ
    FTopNode:TOctreeNode;
    FMeshes:TSXMeshList;        //ÕbV
    FDividedMeshes:TSXMeshList; //̃bVcƓɎ̂ŁAn`p̃bVf[^ʂ͖{
    FFrame:TSXFrame;
    FNodesThrough:Array of TOctreeNode;   //ʂ蔲m[h̃Xg
    FObstacles:Array of Integer;          //ListObstaclesɂĊi[QXg
    FObstaclesChecked:Array of Boolean;   //`FbNςݏQ̏Qۂ̃tO
    FCollidedObstaclesCount: Integer;     //ۂɂԂǂ̐
    FCollidedObstacles:Array of Integer;  //ۂɂԂǂ̔ԍ

    //bV`p̃t[MeshFrames[i][j]ɁA
    //iԖڂ̃IuWFNgjԖڂ̃}eAbVAĊi[
    FMeshFrames:Array of Array of TSXFrame;
    FMaterials:Array of TMQOMaterialData;   //Ɋ֘At}eA
    FTextures:Array of TDGTexture;          //ƑgɂȂeNX`
    FObjectInfo:Array of TMQOObjectData;    //^ZRIuWFNgƂĂ̏AꉞĂ

    FObjectCount:Integer;
    FMaterialCount:Integer;
    FTriangleCount:Integer;

    FCollisionEnable:Array of Boolean;      //iԖڂ̃IuWFNǵA蔻H

    //vpeBnh
    function GetTriangles(idx: Integer): TFacedTriangle3D;
    procedure SetTriangles(idx: Integer; const Value: TFacedTriangle3D);
    function GetMaterials(idx: Integer): TMQOMaterialData;
    procedure SetMaterials(idx: Integer; const Value: TMQOMaterialData);
    function GetCollisionEnable(objectIndex: Integer): Boolean;
    procedure SetCollisionEnable(objectIndex: Integer; const Value: Boolean);
    function GetTianglesObjectIndex(idx: Integer): Integer;
    function GetTrianglesMaterialIndex(idx: Integer): Integer;
    function getCollidedObstacles(idx: Integer): Integer;
    function GetObjects(idx:Integer): TMQOObjectData;
  protected

    //startPosendPos܂ňړۂɒʂ蔲m[hFNodesThroughɋ
    //Xg͏㏑ɒǉĂ̂ŁAVKɃXgƂClearNodesThroughĂԂׂ
    procedure GetNodesThrough(const startPos:D3DVECTOR; const endPos:D3DVECTOR);
    procedure ClearNodesThrough;  //ꂽm[hXgNA

    //FNodesThroughɓĂm[hAOp`oBd͎菜
    procedure ListObstacles;
    //ɂČoQXg̗vfQbg
    function GetEnumeratedObstacles(idx: DWord): Integer;
    function GetEnumeratedObstaclesCount: DWord;

    //startPosendPos܂œƂ̂Ƃ܂ʒu
    //collideAll = True ̎AcollisionEnable𖳎āA񋓂ꂽSĂ̕ǂƂԂ
    //̒ȉcollisionEnable΁A蔲邯ǏՓˎ̂͌m\AƂ
    //̂邱ƂoB
    //invmatrixɂ́AOctreeɊ܂܂ǂ̖@AΏۂƂȂ镨̂̍Wnɕϊs
    //boundsRadiiɂ́Aȋx,y,z̔aݒ肷ׂ
    function GetCollideInfoEllipsoid(var info:TCollisionInfo; const startPos:D3DVECTOR;
      const endPos:D3DVECTOR; const invmtrx:D3DMATRIX; const boundsRadii:D3DVECTOR; epsilon:Single = 1E-6; collideAll:Boolean = False):Boolean;
  public
    constructor Create(ADG:TDGCarad);
    destructor Destroy; override;

    //bV瓖蔻݂̂̃f[^
    procedure BuildFromMeshes(minGridSize:Single; margin:Single);

    //MQOt@CA蔻EOEIuWFNg𒊏o
    procedure BuildFromMQO(filename:String; minGridSize:Single;
      margin:Single; meshTris:Integer = 512; invertX:Boolean = True; multiplier:Single = 1.0);

    function FindNodeFromPosition(const pos:D3DVECTOR):TOctreeNode;  //ʒum[hT

    //se܂ňړ镨̂̓蔻
    //ԂlFՓ˂xłNĂTrue NĂȂȂFalse
    //goalɂ́AՓ˂ĂȂȂê܂܁Aꍇ͏Փ˂ɂĈʒuςꂽl
    //boundɂ́AՓ˂m̂ޑȋ
    //mtrxɂ́Abound݂̑WnAOctreȇ݂Wnւ̕ϊs
    function CollisionCheck(const _s:D3DVECTOR; const _e:D3DVECTOR; const mtrx:D3DMATRIX; const bound:TEllipsoid3D; var goal:D3DVECTOR; epsilon:Single = 1E-6):Boolean;

    //P蔻
    function CollisionCheckOnce(const _s:D3DVECTOR; const _e:D3DVECTOR; const mtrx:D3DMATRIX; const bound:TEllipsoid3D; var goal:D3DVECTOR; epsilon:Single = 1E-6):Boolean;

    //Ōɍs蔻ɂāAۂɏՓ˂̂̐ƊeX̔ԍ
    property CollidedObstaclesCount:Integer read FCollidedObstaclesCount;
    property CollidedObstacles[idx:Integer]:Integer read getCollidedObstacles;

    property TopNode:TOctreeNode read FTopNode;
    property NodeCount:Integer read FNodeCount;
    property Frame:TSXFrame read FFrame write FFrame; //Octree̍Wni[t[

    //TrianglesŏQ̍W܂ł邪ADivideȂƃm[hɂ͔fȂ
    //(蔻肪Ȃ)̂ŒӂKv
    property Triangles[idx:Integer]:TFacedTriangle3D read GetTriangles write SetTriangles;  //Q
    property TrianglesObjectIndex[idx:Integer]:Integer read GetTianglesObjectIndex;
    property TrianglesMaterialIndex[idx:Integer]:Integer read GetTrianglesMaterialIndex;
    property Meshes:TSXMeshList read FMeshes;           //bV
    property Materials[idx:Integer]:TMQOMaterialData read GetMaterials write SetMaterials;
    property Objects[idx:Integer]:TMQOObjectData read GetObjects;

    //O}eAԍT
    function FindMaterial(const name:String):Integer;
    //OIuWFNgԍT
    function FindObject(const name:String):Integer;

    //}eAEIuWFNgԍ烁bVt[T
    function FindMeshFrame(iObject,iMaterial:Integer):TSXFrame; overload;
    //^ZRCAobjectName,materialName烁bV̊i[Ăt[𓾂
    function FindMeshFrame(const objectName:String; const materialName:String):TSXFrame; overload;

    //Փ˔̗LcgCAOPʂł͂ȂA^ZRIuWFNgP
    property CollisionEnable[objectIndex:Integer]:Boolean read GetCollisionEnable write SetCollisionEnable;

    //e
    property MaterialCount:Integer read FMaterialCount;
    property ObjectCount:Integer read FObjectCount;
    property TriangleCount:Integer read FTriangleCount;

    //fobOp
    property EnumeratedObstacles[idx:DWord]:Integer read GetEnumeratedObstacles;
    property EnumeratedObstaclesCount:DWord read GetEnumeratedObstaclesCount;

end;

//DWORDXg
TOctreeIndexList = class
  private
    FCapacity:DWord;
    FCount:DWord;
    FIndices:Array of DWord;
    function GetIndices(idx: Integer): DWORD;
    procedure SetIndices(idx: Integer; const Value: DWORD);
    procedure SetNewCapacity(newCapacity:DWord);
  public
    constructor Create;
    destructor Destroy; override;
    property Indices[idx:Integer]:DWORD read GetIndices write SetIndices; default;
    procedure Add(value:DWORD);
    procedure Delete(idx:Integer);
    procedure Clear;
    property Count:DWord read FCount;
end;

//OctreeNodew肷邽߂̒萔
const
  oniXnZnYn:TOctreeNodeIndex = 0;
  oniXpZnYn:TOctreeNodeIndex = 1;
  oniXnZpYn:TOctreeNodeIndex = 2;
  oniXpZpYn:TOctreeNodeIndex = 3;
  oniXnZnYp:TOctreeNodeIndex = 4;
  oniXpZnYp:TOctreeNodeIndex = 5;
  oniXnZpYp:TOctreeNodeIndex = 6;
  oniXpZpYp:TOctreeNodeIndex = 7;

  oniXnYnZn:TOctreeNodeIndex = 0;
  oniXpYnZn:TOctreeNodeIndex = 1;
  oniXnYnZp:TOctreeNodeIndex = 2;
  oniXpYnZp:TOctreeNodeIndex = 3;
  oniXnYpZn:TOctreeNodeIndex = 4;
  oniXpYpZn:TOctreeNodeIndex = 5;
  oniXnYpZp:TOctreeNodeIndex = 6;
  oniXpYpZp:TOctreeNodeIndex = 7;

  oniXpositive:TOctreeNodeIndex = 1;
  oniYpositive:TOctreeNodeIndex = 4;
  oniZpositive:TOctreeNodeIndex = 2;
  oniXnegative:TOctreeNodeIndex = 0;
  oniYnegative:TOctreeNodeIndex = 0;
  oniZnegative:TOctreeNodeIndex = 0;

  oniFirstNode:TOctreeNodeIndex = 0;
  oniLastNode:TOctreeNodeIndex = 7;

//MQOt@Cǂݍ݂悤FVF
  FVF_MQOVERTEX:DWord = (D3DFVF_XYZ Or D3DFVF_NORMAL Or D3DFVF_DIFFUSE Or D3DFVF_TEX1);


implementation



{ TOctree }


//bVǂݍ
procedure TOctree.BuildFromMeshes(minGridSize: Single; margin:Single);
var
  i,j,k:Integer;
  p1,p2,p3:D3DVECTOR;
  pIBuf:PWord;
  pVBuf:pByte;
  bounds:TBox3D;
  gs:Single;    //Ŝ[߂̂ɕKvȃObh̃TCY
  sceneSize:Single; //V[̑傫
  nLevel:Integer;
  totalFaceCount,Count:DWord;
  center:D3DVECTOR;

  //_񂩂ʒu𔲂ăQbg
  function ExtractP(iMesh,idx:Integer):D3DVECTOR;
  var
    pv:pByte;
  begin
    pv:=pVBuf;
    Inc(pV, idx * meshes[iMesh].VBuf.VertexSize);
    Move(pv^, result, sizeof(D3DVECTOR));
  end;

  //Op`
  function ConstructTri(const p1,p2,p3:D3DVECTOR):TFacedTriangle3D;
  begin
    result.A:=p1;
    result.B:=p2;
    result.C:=p3;
    result.N:=NowNormalFromPoints(p1,p2,p3);
  end;
begin

  //gCAǑvZ
  totalFaceCount:=0;

  for i:=0 to Meshes.Count-1 do begin
    Inc(totalFaceCount,Meshes[i].FaceCount);
  end;
  FTriangleCount:=totalFaceCount;

  SetLength(FTriangles, totalFaceCount);

  bounds.Min:=Vector(Infinity,Infinity,Infinity);
  bounds.Max:=Vector(NegInfinity,NegInfinity,NegInfinity);

  count:=0;
  For i:=0 to Meshes.Count-1 do begin
    //ʒu񂪂ȂbVł͘bɂȂȂ킯
    if ((Meshes[i].VBuf.FVF And D3DFVF_POSITION_MASK) = 0) Or (Meshes[i].VBuf.Count = 0) then begin
      //if (mesh.VBuf.FVF And D3DFVF_NORMAL = 0) then begin
        DGCarad_PutDebugMessage(Format('TOctTree : _̈ʒu񂪊܂܂ĂȂbVł (%s)',[Meshes[i].VBufName]));
        continue;
      //end;
    end;

    //gbvm[hɁAbV̈ʒuOp`Rs[
    pVBuf:=Meshes[i].VBuf.Lock(0, Meshes[i].VBuf.Count, D3DLOCK_READONLY);
    pIBuf:=Meshes[i].IBuf.Lock(0, Meshes[i].IBuf.Count, D3DLOCK_READONLY);

    for j:=0 to Meshes[i].FaceCount-1 do begin
      p1:=ExtractP(i,pIBuf^);
      //n1:=ExtractN(pIBuf^);
      Inc(pIBuf);

      p2:=ExtractP(i,pIBuf^);
      //n2:=ExtractN(pIBuf^);
      Inc(pIBuf);

      p3:=ExtractP(i,pIBuf^);
      //n3:=ExtractN(pIBuf^);
      Inc(pIBuf);

      Triangles[count + j]:=ConstructTri(p1,p2,p3);

      //oE_̍XV
      for k:=0 to 2 do begin
        with bounds, Triangles[count + j] do begin
          max.x := math.max(max.x, Vertices[k].x);
          min.x := math.min(min.x, Vertices[k].x);

          max.y := math.max(max.y, Vertices[k].y);
          min.y := math.min(min.y, Vertices[k].y);

          max.z := math.max(max.z, Vertices[k].z);
          min.z := math.min(min.z, Vertices[k].z);
        end;
      end;

      TopNode.TriangleIndices.Add(count + j);
    end;
    Inc(count,Meshes[i].FaceCount);
    Meshes[i].VBuf.Unlock;
    Meshes[i].IBuf.Unlock;
  end;

  //V[̈ӂ̑傫ƒS
  sceneSize := math.Max(bounds.max.x-bounds.min.x, math.max(bounds.max.y-bounds.min.y, bounds.max.z-bounds.min.z));
  center:=NowScale(NowAdd(bounds.Max,bounds.Min),0.5);

  //Obh2ׂ̂{ĂāAV[Ŝ傫Ȃ܂
  gs:=minGridSize;
  nLevel:=0;
  while gs < sceneSize do begin
    gs:=gs * 2.0;
    Inc(nLevel);
  end;

  //
  TopNode.Divide(gs, center, nLevel, margin);
end;

//MQOt@CA蔻EOEIuWFNg𒊏o
procedure TOctree.BuildFromMQO(filename:String;minGridSize:Single;
  margin:Single; meshTris:Integer = 512; invertX:Boolean = True;
  multiplier:Single = 1.0);
var
  mqoPath,mqoName:String;
  mqo:TMQOFile;
  dbg:String;   //fobO|[gp
  nMeshes:Integer;
  newMesh:TSXMesh;
  i,j,k:Integer;
  pVB:PByte;
  pIB:PWord;
  tmpI:Word;
  x:Single;
  tmpFilePath:Array [0..MAX_PATH] of Char; //e|̃t@C
  tmpFileName:Array [0..MAX_PATH] of Char; //e|̃t@C
  tmpFileExt:Array[0..2] of Char;
  textureNames:Array of String;
  nTextures,iMesh:Integer;
  alreadyLoaded:Boolean;
  newFrame:TSXFrame;
  totalFaceCount,iFace,iMaterial:Integer;

  colA,col,dif,spec,amb,emi:D3DCOLOR;  //F


  ///V[Ot񕪂cparentɌqĂqt[̊ԂɁA̐Vet[
  function divideSceneGraph(parent:TSXFrame):Boolean;
  var
    i,j,iteration:Integer;
    centerA,centerB:D3DVECTOR;  //ZgCh̍W
    meanA,meanB:D3DVECTOR;      //AɑWcƁABɑWc̕ϒl
    distAsq,distBsq:Single;
    nFrames:Integer;
    countA,countB:Integer;
    newParentA,newParentB:TSXFrame; //VEet[Bet[͑ct[ƂȂ

    function calcDistSq(idx:Integer; p:D3DVECTOR):Single;
    begin
      result:=NowDistanceSQ(parent.Children[idx].Bounds.Center, p);
    end;

    procedure selectCentroid;
    var
      selA,selB:Integer;
    begin
      selA:=0;
      selB:=0;

      while selA=selB do begin
        selA:=Random(nFrames);
        selB:=Random(nFrames);
      end;

      centerA:=parent.Children[selA].Bounds.Center;
      centerB:=parent.Children[selB].Bounds.Center;
    end;
  begin
    nFrames:=parent.Children.Count;
    result:=False;

    //KvȂ
    if nFrames <= 2 then begin
      exit;
    end;

    //kσASYŁAV[Ot̃NX^ɕꍇ́A
    //eX̃NX^̒S߂
    iteration:=Round(Log2(nFrames)+1);
    i:=iteration;
    selectCentroid; //ZgChIŁAcenterA,centerBɓ

    while i > 0 do begin
      meanA:=Vector(0,0,0);
      meanB:=Vector(0,0,0);
      countA:=0;
      countB:=0;

      //d
      for j:=0 to nFrames-1 do begin
        distAsq := calcDistSq(j, centerA);
        distBsq := calcDistSq(j, centerB);

        if distAsq < distBsq then begin
          meanA:=NowAdd(meanA, parent.Children[j].Bounds.Center);
          Inc(countA);
        end else begin
          meanB:=NowAdd(meanB, parent.Children[j].Bounds.Center);
          Inc(countB);
        end;
      end;

      //ďʂAVlɂ
      if (countA = 0) Or (countB = 0) then begin
        //ZgCh
        selectCentroid;
        i:=iteration+1;
      end else begin
        centerA:=NowScale(meanA, 1/countA);
        centerB:=NowScale(meanB, 1/countB);
      end;

      Dec(i);
    end;

    //VEet[̍쐬ƁAqt[̐VEet[ւ̊蓖
    newParentA:=TSXFrame.Create(parent);
    newParentB:=TSXFrame.Create(parent);

    //ɕ
    while parent.Children[0] <> newParentA do begin
      distAsq := calcDistSq(0, centerA);
      distBsq := calcDistSq(0, centerB);

      if distAsq < distBsq then begin
        parent.Children[0].Parent:=newParentA;
      end else begin
        parent.Children[0].Parent:=newParentB;
      end;
    end;

    newParentA.Style:=sxfsMeshContainer;
    newParentB.Style:=sxfsMeshContainer;
    newParentA.EnableMeshTransform:=False;
    newParentB.EnableMeshTransform:=False;
    newParentA.UpdateBounds(True);
    newParentB.UpdateBounds(True);

    result:=True;
  end;


  //ċAIɃV[Ot𕪊
  procedure divideRec(parent:TSXFrame);
  begin
    //divideSceneGraphœ񕪂ꂽV[́Aparent.Children[0],[1]ɓ
    if divideSceneGraph(parent) then begin
      with parent.Bounds do
        DGCarad_PutDebugMessage(Format('t[ center(%f,%f,%f) radius:%fȉ̓ɕ܂',[
          Center.x,Center.y,Center.z, Radius]));

      with parent.Children[0].Bounds do
        DGCarad_PutDebugMessage(Format('  center(%f,%f,%f) radius:%f',[
          Center.x,Center.y,Center.z, Radius]));
      with parent.Children[1].Bounds do
        DGCarad_PutDebugMessage(Format('  center(%f,%f,%f) radius:%f',[
          Center.x,Center.y,Center.z, Radius]));

      divideRec(parent.Children[0]);
      divideRec(parent.Children[1]);

    end;
  end;
begin

  //XĂ̓NA
  for i:=0 to Length(FTextures)-1 do
    FreeAndNil(FTextures[i]);
  FTextures:=Nil;

  Meshes.Clear;

  for i:=0 to Length(FMeshFrames)-1 do begin
    for j:=0 to FMaterialCount -1 do begin
      if FmeshFrames[i,j] <> Nil then begin
        FMeshFrames[i,j].Free;
      end;
    end;
    FMeshFrames[i]:=Nil;
  end;



  //eNX`ƂƂ̃pXo
  mqo:=TMQOFile.Create;
  mqo.Load(filename);

  FObjectCount:=mqo.ObjectCount;
  FMaterialCount:=mqo.mMaterial.Count;

  mqo.SetAddVertexColor(True);
  mqo.SetAddUVVector(True);
  mqo.SetAddNormal(True);

  if multiplier <> 1.0 then begin
    mqo.MultipleSize(multiplier);
  end;

  mqoPath:=ExtractFilePath(filename);
  if mqoPath = '' then
    mqoPath:='.\';
  mqoName:=ExtractFileName(fileName);

  //t[Xg̗vfm)
  SetLength(FMeshFrames, FObjectCount);
  for i:=0 to FObjectCount-1 do begin
    SetLength(FMeshFrames[i], FMaterialCount);
    for j:=0 to FMaterialCount-1 do begin
      FMeshFrames[i,j]:=Nil;
    end;
  end;

  //}eA̍쐬
  SetLength(FMaterials, mqo.mMaterial.Count);
  for i:=0 to mqo.mMaterial.Count-1 do
    FMaterials[i]:=mqo.mMaterial.Data[i];

  //IuWFNg񃊃Xg̍쐬
  SetLength(FObjectInfo, mqo.ObjectCount);
  for i:=0 to mqo.ObjectCount-1 do
    FObjectInfo[i]:=mqo.mObject[i].Data;

  //eNX`̓ǂݍ
  nTextures:=0;
  SetLength(textureNames, mqo.mMaterial.Count);
  for i:=0 to mqo.mMaterial.Count-1 do begin
    //eNX`t@Cꍇ̓pX
    if (Trim(mqo.mMaterial.Data[i].Texture) = '') Or (not FileExists(mqoPath + mqo.mMaterial.Data[i].Texture)) then
      continue;

    //deNX`͓ǂ܂Ȃ
    alreadyLoaded:=False;
    for j:=0 to nTextures-1 do begin
      if (mqo.mMaterial.Data[i].Texture = textureNames[j]) then begin
        alreadyLoaded:=True;
        break;
      end;
    end;

    if not alreadyLoaded then begin
      SetLength(FTextures, nTextures+1);
      textureNames[nTextures]:=mqo.mMaterial.Data[i].Texture;
      dbg:=Format('%s @ %s',[mqo.mMaterial.Data[i].Texture, mqoName]);
      FTextures[nTextures]:=TDGTexture.Create(DG, DGFMT_ARGB, 0, D3DPOOL_MANAGED, 0, dbg);
      FTextures[nTextures].LoadFromFile(mqoPath +  textureNames[nTextures]);

      Inc(nTextures);
    end;

  end;


  //bV̍쐬
  totalFaceCount:=0;
  for i:=0 to FObjectCount-1 do begin
    if mqo.mObject[i].Data.visible <> 0 then begin

      //e|āAMQOSXɕϊ
      StrPCopy(tmpFileExt, 'sxlibmqo');
      GetTempPath(MAX_PATH, tmpFilePath);

      mqo.mObject[i].PolygonDivide;
      mqo.mObject[i].FaceEdge;

      for j:=0 to FMaterialCount-1 do begin
        GetTempFileName(tmpFilePath, tmpFileExt, 1, tmpFileName);
        if FileExists(tmpFileName) then
          DeleteFile(tmpFileName);
        mqo.mObject[i].ExportSXFormat(tmpFileName, j);

        if FileExists(tmpFileName) then begin
          //t@CꍇcObject#i Material#j Ȃ镨̂AƂ
          dbg:=Format('%s(material:%s) @ %s',[mqo.mObject[i].Data.Name, mqo.mMaterial.Data[j].Name, mqoName]);
          newMesh:=TSXMesh.Create(DG, dbg+'pVB', dbg+'pIB');
          newMesh.LoadFromFile(tmpFileName);

          //X]
          if invertX then begin
            pVB:=newMesh.VBuf.Lock(0, 0, 0);
            for k:=0 to newMesh.VBuf.Count-1 do begin
              Move(pVB^, x, sizeof(Single));
              x:=-x;
              Move(x, pVB^, sizeof(Single));

              Inc(pVB,sizeof(D3DVECTOR));  //@܂ŃWv
              Move(pVB^, x, sizeof(Single));
              x:=-x;
              Move(x, pVB^, sizeof(Single));

              Inc(pVB, newMesh.VBuf.VertexSize - sizeof(D3DVECTOR));
            end;
            newMesh.VBuf.Unlock;

            //ʂ̒t]
            newMesh.IBuf.Lock(0,0,0);
            for k:=0 to newMesh.FaceCount-1 do begin
              tmpI:=newMesh.IBuf.Indices[k*3+1];
              newMesh.IBuf.Indices[k*3+1]:=newMesh.IBuf.Indices[k*3+2];
              newMesh.IBuf.Indices[k*3+2]:=tmpI;
            end;
            newMesh.IBuf.Unlock;

          end;
          newMesh.UpdateBounds;
          Meshes.Add(newMesh);

          Inc(totalFaceCount, newMesh.FaceCount);

          //bVi[t[쐬
          newFrame:=TSXFrame.Create(Frame);
          FMeshFrames[i,j]:=newFrame;
          newFrame.Parent:=Frame;
          newFrame.Mesh:=newMesh;
          {܂Ȃ̂ł̂M̖A}eAϊ}
          with Materials[j] do begin
            col:=D3DCOLOR_COLORVALUE( color.r, color.g, color.b, color.a);
            colA:=Round(color.a * 256.0);
            colA:=min(colA, 255);
            colA:=max(colA, 0);
            //FNowScaleColor̓=255ɃZbg
            dif:=NowScaleColor(col, diffuse) And $00FFFFFF Or (colA shl 24);
            spec:=NowScaleColor(col,Specular);
            amb:=NowScaleColor(col, Ambient);
            emi:=NowScaleColor($FFFFFFFF, Emissib);
            newFrame.Material:=MakeMaterial(dif,spec,amb,emi, SPower);
          end;
          if colA <> 255 then
            newFrame.BlendMode:=sxbAlpha
          else
            newFrame.BlendMode:=sxbDefault;

          //eNX`
          newFrame.Texture:=Nil;
          for k:=0 to nTextures-1 do begin
            if textureNames[k] = mqo.mMaterial.Data[j].Texture then begin
              newFrame.Texture := FTextures[k];
              break;
            end;
          end;

          //e|
          DeleteFile(tmpFileName);
        end;
      end;
    end;
  end;

  //ȏŁAMQO̓ǂݍݏI
  mqo.Free;
  textureNames:=Nil;


  {V[Ot̍œKc
    MeshFrames[i,j]ɓĂt[̐eq֌WAȉ̂悤
    1.ŜjAɃjcJԂ
    2.߂m[hmŏIIɌZ퓯mƂȂ}

  //xGȃV[ȊOł͂ĒxȂƔ
  //FFRame.UpdateBounds(False);
  //divideRec(FFrame);


  {ɁAQm[h̍XV}

  //QƂēe|ŚAǂ̃}eAEIuWFNgR
  SetLength(FTrianglesMaterialIndex, totalFaceCount);
  SetLength(FTrianglesObjectIndex, totalFaceCount);
  iMesh:=0;
  iFace:=0;
  for i:=0 to ObjectCount-1 do begin
    for j:=0 to MaterialCount-1 do begin
      if FMeshFrames[i,j] <> Nil then begin
        iMaterial:=j;
        for k:=0 to Meshes[iMesh].FaceCount-1 do begin
          FTrianglesObjectIndex[iFace]:=i;
          FTrianglesMaterialIndex[iFace]:=j;
          Inc(iFace);
        end;
        Inc(iMesh);
      end;
    end;
  end;

  //蔻tȌ(STrue)
  SetLength(FCollisionEnable, totalFaceCount);
  For i:=0 to totalFaceCount-1 do
    FCollisionEnable[i]:=True;

  //Meshes瓖蔻Octreeɓ
  BuildFromMeshes(minGridSize, margin);

  //ŌɁAbV̕
  iMesh:=0;
  for i:=0 to FObjectCount-1 do begin
    for j:=0 to FMaterialCount-1 do begin
      if FMeshFrames[i,j] <> Nil then begin
        SXSubDivideMesh(DG, Meshes[iMesh], FMeshFrames[i,j], FDividedMeshes,  meshTris);
        Inc(iMesh);
      end;
    end;
  end;
  
  FFRame.UpdateBounds(False);
  FFrame.ActivateBounds;

  //fobOp
  FFrame.DumpFrameStats;
  FFrame.RenderAttr:=4649;
end;


{
function TOctree.CollisionCheck(_s, _e: D3DVECTOR;
  const bound: TEllipsoid3D; var goal: D3DVECTOR; epsilion:Single = 1E-6): Boolean;
var
  s,e:D3DVECTOR;  //on_AڕWn_
  h:Array[0..2] of TOctreeNode;
  dir,delta:D3DVECTOR;  //is(dir͐Kς݁Adelta͈ړ)
  cr:Single;            //Փ˔a
  cr_dir:D3DVECTOR;     //cr*dir
  se_len:Single;     //Length(delta)
  e_se:D3DVECTOR;       //epsilon * delta
  i,j:Integer;

  iWall,nWall,srcIndex,destIndex:DWord;  //ǂ̐
  plane:TPlane3D;
  wallIndices:Array of DWord;
  wall:Array of TFacedTriangle3D; //
  facing:Array of Single; //ǂ̐isɑ΂
  checked:Array of Boolean;
  collided:Boolean;

  se:TLIne3D;     //se܂ޒ
  c:D3DVECTOR;    //Փ˒n_
  ce:D3DVECTOR;   //Փ˒n_e܂ł̃xNg
  ce_n,ce_t:D3DVECTOR;  //xNgcéA@Ɛڐ
  backDir:D3DVECTOR;  //Փ˒n_̎Zop
  n_dir:Single;

  iteration:Integer;

  //[
  procedure QSort(left,right:Integer);
  var
    i,j:Integer;
    tmp:TFacedTriangle3D;
    s,t:Single;
  begin
    if (left<right) then begin
      s:=facing[(left+right) Shr 1];
      i:=left-1;
      j:=right+1;
      while True do begin

        repeat
          Inc(i);
        until (facing[i]<=s);

        repeat
          Dec(j);
        until (facing[j]>=s);

        if (i>=j) then
          break;

        t:=facing[i];
        facing[i]:=facing[j];
        facing[j]:=t;

        tmp:=wall[i];
        wall[i]:=wall[j];
        wall[j]:=tmp;
      end;
      QSort(left,i-1);
      QSort(j+1,right);
    end;
  end;

  procedure QSortWallIndex(left,right:Integer);
  var
    i,j:Integer;
    s,t:DWord;
  begin
    if (left<right) then begin
      s:=wallIndices[(left+right) Shr 1];
      i:=left-1;
      j:=right+1;
      while True do begin

        repeat
          Inc(i);
        until (wallIndices[i]<=s);

        repeat
          Dec(j);
        until (wallIndices[j]>=s);

        if (i>=j) then
          break;

        t:=wallIndices[i];
        wallIndices[i]:=wallIndices[j];
        wallIndices[j]:=t;

      end;
      QSortWallIndex(left,i-1);
      QSortWallIndex(j+1,right);
    end;
  end;

  //isƕǂ̌vZāAfacingɓAfacingŕǃXg\[g
  //S0ȉAFalseԂ
  function calcFacingAndSort:Boolean;
  var
    i:Integer;
  begin
    result:=False;
    for i:=0 to nWall-1 do begin
      facing[i]:= - NowDotProduct(wall[i].N, dir);
      if facing[i] > 0 then begin
        result:=True;
      end;
    end;

    QSort(0,nWall-1);
  end;
begin
  result:=False;

  s:=NowAdd(_s, bound.Center);
  e:=NowAdd(_e, bound.Center);

  delta:=NowSub(e,s);
  dir:=NowNormalize(delta);

  cr:=NowLength(bound.Radii);
  cr_dir:=NowScale(dir, cr);

  //se܂ރm[hmc苅̕OɐL΂ʒuƁAԒn_Ńm[hQbg
  h[0]:=FindNodeFromPosition(NowSub(s, cr_dir));
  h[1]:=FindNodeFromPosition(NowScale(NowAdd(e,s),0.5));
  h[2]:=FindNodeFromPosition(NowAdd(e, cr_dir));


  (* ǔԍXg *)
  //܂Aǔԍobt@m
  nWall:=0;
  for i:=0 to 2 do begin
    //dm[h͒TȂ
    if i > 0 then begin
      if h[i-1] = h[i] then
        continue;
    end;
    Inc(nWall,h[i].TrianglesCount);
  end;

  //m[hTǁAǂĂȂ
  if nWall = 0 then begin
    result:=False;
    goal:=e;
    exit;
  end;

  //ǔԍXg
  SetLength(wallIndices,nWall);
  iWall:=0;
  for i:=0 to 2 do begin
    //dm[h͒TȂ
    if i > 0 then begin
      if h[i-1] = h[i] then
        continue;
    end;
    For j:=0 to h[i].TriangleIndices.Count-1 do
      wallIndices[iWall + j]:=h[i].TriangleIndices[j];
    iWall:=h[i].TriangleIndices.Count;
  end;


  //\[gĂAd
  QSortWallIndex(0, nWall-1);
  srcIndex:=1;
  destIndex:=0;
  while srcIndex < nWall do begin
    if wallIndices[destIndex] = wallIndices[srcIndex] then begin
      Inc(srcIndex);
    end else begin
      Inc(destIndex);
      wallIndices[destIndex]:=wallIndices[srcIndex];
      Inc(srcIndex);
    end;
  end;
  nWall:=destIndex+1;


  //ǃXg
  SetLength(wall, nWall);
  SetLength(facing, nWall);
  SetLength(checked,nWall);
  ZeroMemory(@checked[0], nWall * Sizeof(Boolean));

  For i:=0 to nWall-1 do
    wall[i]:=Triangles[wallIndices[i]];


  //Ń\[g
  calcFacingAndSort;

  //isɑ΂1ɋ߂̂T
  goal:=e;
  collided:=False;
  iteration:=8; //Ƃ肠A8̕ǂɃqbg͍lȂ

  while iteration > 0 do begin
    for i:=0 to nWall-1 do begin
      if checked[i] then
        continue;
      
      se_len:=NowLength(delta);
      e_se:=NowScale(delta, epsilion);
      cr:=NowCollisionRadius(bound, wall[i].N);
      cr_dir:=NowScale(dir, cr);

      if NowPointInPillarThick(s, wall[i], NowNeg(delta), cr) then begin
        //Փ˂
        collided:=True;
        result:=True;

        //wall[i]܂ޕʂŁAse؂A؂_߂Ԃ_
        plane.Normal:=wall[i].N;
        plane.D:= - NowDotProduct(wall[i].N, wall[i].A);
        se:=Line3D(s, dir);
        if not NowIntersectLinePlane(c, se, plane) then begin
          c:=e;  //̂XJP[Xc肦Ȃ̂łԂȂƂɂĂ
          goal:=e;
          collided:=False;
        end else begin
          //checked[i]:=True;

          //cɓĂ͕̂ʏ̍WȂ̂ŁAdirɂǂĂ
          //@dir̂ȂpƂƂƁAdircr / cos ߂Kv
          n_dir:=NowDotProduct(wall[i].N, dir);

          if (Abs(n_dir)<0.001) Or ((-cr / n_dir) > se_len) then begin
            //ǂƐis90x߂pxɂȂĂ邽߁A߂肷P[XB
            c:=NowSub(s,e_se);
            //backDir:=NowScale(wall[i].N,cr);
            //c:=NowAdd(c,backDir);
          end else begin
            backDir:=NowAdd(NowScale(dir, cr / n_dir),e_se);
            c:=NowAdd(c,backDir);
          end;
          //Փˌ̒n_̎Zo
          ce:=NowSub(e,c);
          ce_n:=NowScale(wall[i].N, NowDotProduct(wall[i].N, ce));
          ce_t:=NowSub(ce, ce_n);

          //SeՓ
          //goal:=NowAdd(NowSub(c, ce_n),ce_t);

          //eՓ(ǃY)
          goal:=NowAdd(c, NowScale(ce_t,1));

          //Փ˂Aς̂ŁÂ߂̌vZׂEo
          break;
        end;
      end;
    end;
    //ĂȂȂnj
    if not collided then
      break;

    //ςĎ̃[vAsĂ݂[
    //ZogoalendAcX^[gƂă[v
    //AڕWlɂقړBĂƂ݂Ȃꍇ́Ał؂
    if NowDistance(goal,c) < 1E-6 then
      break;
    e:=goal;
    s:=c;
    dir:=NowNormalize(NowSub(e,s));

    //SĂ̕ǂɑ΂ĉɓĂȂAȏ`FbNȂ
    if not calcFacingAndSort then
      break;

    Dec(iteration);
    collided:=False;
  end;

  //fobOpAɂ߂荞ło
  //if goal.y < 2.0 then
    DGCarad_PutDebugMessage(Format('%d ... %f,%f,%f', [iteration, goal.x,goal.y,goal.z]));

  facing:=Nil;
  wall:=Nil;
  wallIndices:=Nil;
  checked:=Nil;
end;
}


function TOctree.GetCollideInfoEllipsoid(var info:TCollisionInfo; const startPos:D3DVECTOR;
  const endPos:D3DVECTOR; const invmtrx:D3DMATRIX; const boundsRadii:D3DVECTOR; epsilon:Single = 1E-6; collideAll:Boolean = False):Boolean;
var
  s,e:D3DVECTOR;        //on_AڕWn_
  dir,delta:D3DVECTOR;  //is(dir͐Kς݁Adelta͈ړ)
  cr:Single;            //Փ˔a
  cr_dir:D3DVECTOR;     //cr*dir
  delta_len:Single;        //Length(delta)
  i:Integer;
  collided:Boolean;

  fraction,bestFraction:Single; //0̎s, 1̎eɋ邱Ƃ
  bestObstacle:DWord;
  plane:TPlane3D;
  se:TLIne3D;     //se܂ޒ
  c:D3DVECTOR;    //Փ˒n_
  n_dir:Single;
  obs:TFacedTriangle3D; //Q
  obsN:D3DVECTOR;       
begin

  // s:=NowAdd(startPos, bound.Center);
  //e:=NowAdd(endPos, bound.Center);
  s:=startPos;
  e:=endPos;

  delta:=NowSub(e,s);
  delta_len:=NOwLength(delta);
  dir:=NowNormalize(delta);

  //m[h̑S̏QƂ̓蔻
  bestFraction:=1.0;
  bestObstacle:=$FFFFFFFF;

  for i:=0 to Length(FObstacles)-1 do begin

    collided:=False;
    obs:=FTriangles[FObstacles[i]];

    if (not FObstaclesChecked[i]) and (collideAll Or CollisionEnable[FTrianglesObjectIndex[FObstacles[i]]]) then begin
      //isɑΖʂĂʂƂ蔻肷
      obsN:=NowRotation(obs.N, invmtrx);
      n_dir:=NowDotProduct(dir, obs.N);
      if n_dir < 0 then begin
        cr:=NowCollisionRadius(Ellipsoid3D(Vector(0,0,0),boundsRadii), obsN);
        if NowPointInPillarThick(s, obs, NowNeg(delta), cr) then begin
          //
          collided:=True;
        end;
      end;
    end;

    if collided then begin
      //ĂAr܂łȂB
      //ǂŎ~܂邩vZ
      cr_dir:=NowScale(dir, cr);

      //FObstacles[i]܂ޕʂŁAse؂A؂_߂Ԃ_
      plane.Normal:=obs.N;
      plane.D:= - NowDotProduct(plane.Normal,obs.A);
      se:=Line3D(s, dir);
      if not NowIntersectLinePlane(c, se, plane) then begin
        c:=e;  //̂XJP[Xc肦Ȃ̂łԂȂƂɂĂ
        fraction:=1.0;
      end else begin
        // cr / nEdir߂
        if abs(n_dir) < 0.001 then begin //ق0
          fraction:=0;
        end else if (-cr / n_dir) > delta_len then begin //߂肷(Ƃƃł)
          fraction:=0;
        end else begin
          fraction:=NowLength(NowSub(c,s));
          fraction:=(fraction + cr / n_dir) / delta_len - epsilon;
        end;
      end;
    end else begin
      //ĂȂ̂ŁAŌ܂œ
      fraction:=1.0;
    end;

    if fraction < bestFraction then begin
      bestFraction:=fraction;
      bestObstacle:=i;
    end;
  end;

  if bestObstacle <> $FFFFFFFF then begin
    result:=True;
    info.Fraction:=bestFraction;
    info.CollisionNormal:=FTriangles[FObstacles[bestObstacle]].N;
    info.Stopped:=NowLerp3D(startPos,endPos, info.Fraction);
    info.WallIndex:=FObstacles[bestObstacle];
    FObstaclesChecked[bestObstacle]:=True;
    //info.Stopped:=;
  end else begin
    result:=False;
    info.Fraction:=1.0;
    info.Stopped:=endPos;
  end;
end;


//GetNodesThroughListObstaclesGetCollideInfõZbg
//ǃY@\t
function TOctree.CollisionCheck(const _s:D3DVECTOR; const _e: D3DVECTOR;
  const mtrx:D3DMATRIX; const bound: TEllipsoid3D;  var goal: D3DVECTOR;
  epsilon:Single = 1E-6): Boolean;
var
  s,e,node_s,node_e,dir,cr_dir:D3DVECTOR;
  cr:Single;

  collInfo:TCollisionInfo;
  iteration:Integer;

  ce:D3DVECTOR;   //Փ˒n_瓖̖ڕWn_܂ł̃xNg
  ce_n,ce_t:D3DVECTOR;  //xNgcéA@Ɛڐ

  invmtrx:D3DMATRIX;
  delta:D3DVECTOR;
begin

  dir:=NowNormalize(NowSub(_e,_s));   //is
  cr:=NowLength(bound.Radii);  //Փ˔a̎Zo
  cr_dir:=NowScale(dir,cr);

  node_s:=NowSub(_s,cr_dir);
  node_e:=NowAdd(_e,cr_dir);

  //ϊcmtrx͉]&sړ݂̂\Ɖ
  invmtrx:=NowInvMatrix(mtrx);
  delta:=NowRotation(bound.Center, mtrx);


  //QXg
  ClearNodesThrough;
  GetNodesThrough(node_s, node_e);
  ListObstacles;

  s:=NowAdd(_s,delta);
  e:=NowAdd(_e,delta);

  result:=False;

  FCollidedObstaclesCount:=0;
  iteration:=OCTREE_MAX_COLLIDE; //Ƃ肠A5܂ŕǃY̑ΏۂɂBA4x
  while iteration > 0 do begin
    if GetCollideInfoEllipsoid(collInfo, s,e, invmtrx, bound.Radii, epsilon) then begin

      //Ō܂łǂ蒅Ƃ݂ȂꍇAł؂
      if collInfo.Fraction >= 1.0 then begin
        goal:=e;
        break;
      end;

      FCollidedObstacles[FCollidedObstaclesCount]:=collInfo.WallIndex;
      Inc(FCollidedObstaclesCount);

      //S[Ă
      if iteration = 1 then begin
        goal:=NowSub(collInfo.Stopped, delta);
        break;
      end;

      //ǃY
      ce:=NowSub(e, collInfo.Stopped);
      ce_n:=NowScale(collInfo.CollisionNormal, NowDotProduct(collInfo.CollisionNormal, ce));
      ce_t:=NowSub(ce,ce_n);

      s:=collInfo.Stopped;
      //e:=s;
      e:=NowAdd(s, ce_t); //ǃYÃS[ɒ߂


      //͂A
      Dec(iteration);
      result:=True;
    end else begin
      //ǂɓĂȂ
      goal:=NowSub(collInfo.Stopped, delta);
      break;
    end;
  end;

end;

function TOctree.CollisionCheckOnce(const _s, _e: D3DVECTOR; const mtrx:D3DMATRIX;
  const bound: TEllipsoid3D; var goal: D3DVECTOR;
  epsilon: Single): Boolean;
var
  s,e,node_s,node_e,dir,cr_dir:D3DVECTOR;
  cr:Single;

  collInfo:TCollisionInfo;
  iteration:Integer;

  ce:D3DVECTOR;   //Փ˒n_瓖̖ڕWn_܂ł̃xNg
  ce_n,ce_t:D3DVECTOR;  //xNgcéA@Ɛڐ

  invmtrx:D3DMATRIX;
  delta:D3DVECTOR;
begin

  dir:=NowNormalize(NowSub(_e,_s));   //is
  cr:=NowLength(bound.Radii);  //Փ˔a̎Zo
  cr_dir:=NowScale(dir,cr);

  node_s:=NowSub(_s,cr_dir);
  node_e:=NowAdd(_e,cr_dir);

  //ϊcmtrx͉]&sړ݂̂\Ɖ
  invmtrx:=NowInvMatrix(mtrx);
  delta:=NowRotation(bound.Center, mtrx);


  //QXg
  ClearNodesThrough;
  GetNodesThrough(node_s, node_e);
  ListObstacles;

  s:=NowAdd(_s,delta);
  e:=NowAdd(_e,delta);

  FCollidedObstaclesCount:=0;
  result:=GetCollideInfoEllipsoid(collInfo, s,e, invmtrx, bound.Radii, epsilon);

  if result then begin
    FCollidedObstaclesCount:=1;
    FCollidedObstacles[0]:=collInfo.WallIndex;
    goal:=collInfo.Stopped;
  end;
end;


constructor TOctree.Create(ADG:TDGCarad);
begin
  inherited Create;

  DG:=ADG;
  FNodeCount:=0;
  FTriangles:=Nil;
  FTrianglesMaterialIndex:=Nil;
  FTrianglesObjectIndex:=Nil;
  FTopNode:=TOctreeNode.Create(Self);
  FMeshes:=TSXMeshList.Create(ADG);
  FMeshFrames:=Nil;
  //FMeshFrames:=TSXFrameList.Create;
  FFrame:=TSXFrame.Create(Nil);
  FDividedMeshes:=TSXMeshList.Create(ADG);
  FObjectCount:=0;
  FMaterialCount:=0;
  SetLength(FCollidedObstacles, OCTREE_MAX_COLLIDE);
end;

destructor TOctree.Destroy;
var
  i:Integer;
begin
  FTriangles:=Nil;
  FTrianglesMaterialIndex:=Nil;
  FTrianglesObjectIndex:=Nil;
  FCollisionEnable:=Nil;
  FCollidedObstacles:=Nil;

  FNodesThrough:=Nil;
  FObstacles:=Nil;
  FObstaclesChecked:=Nil;

  if Assigned(FMeshes) then
    FMeshes.Free;
  if Assigned(FDividedMeshes) then
    FDividedMeshes.Free;

  FFrame.Free;

  if Assigned(FMeshFrames) then begin
    for i:=0 to FObjectCount-1 do begin
      {
      //FFrame̔zɂȂĂ̂ŁAFmeshFrames[i,j]FreeȂĂ
      for j:=0 to FMaterialCount -1 do begin
        if FmeshFrames[i,j] <> Nil then begin
          FMeshFrames[i,j].Free;
        end;
      end;
      }
      FMeshFrames[i]:=Nil;
    end;
    FMeshFrames:=Nil;
  end;

  if Assigned(FTextures) then begin
    for i:=0 to Length(Ftextures)-1 do
      if Assigned(FTextures[i]) then
        Ftextures[i].Free;
    FTextures:=Nil;
  end;

  FMaterials:=Nil;
  FObjectInfo:=Nil;

  FTopNode.Free;

  inherited;
end;

function TOctree.FindNodeFromPosition(const pos: D3DVECTOR): TOctreeNode;
var
  idx:TOctreeNodeIndex;
  node:TOctreeNode;
begin
  node:=TopNode;

  while True do begin

    if pos.x > node.Center.x then
      idx:=oniXpositive
    else
      idx:=oniXnegative;
    if pos.z > node.Center.z then
      Inc(idx,oniZpositive);
    if pos.y > node.Center.y then
      Inc(idx,oniYpositive);

    if not Assigned(node.Children[idx]) then
      break;
    node:=node.Children[idx];

  end;

  result:=node;
end;

const
  MAX_NODE_FIND = 256;  //̊֐ŗpAőTm[h

//startPosendPosɈړۂɒʂ蔲m[hFNodesThroughɃXgAbv
//Xg͏㏑ɒǉĂ̂ŁAVKɃXgƂClearNodesThroughĂԂׂ
procedure TOctree.GetNodesThrough(const startPos, endPos: D3DVECTOR);
var
  i:Integer;
  startNode,endNode:TOctreeNode;
  nFound:Integer;
  nodeFound:Array[0..MAX_NODE_FIND-1] of TOctreeNode;

  //m[hnodeFoundɂ킦BȂȂFalse
  function addNode(node:TOctreeNode):Boolean;
  begin
    if nFound < MAX_NODE_FIND then begin
      nodeFound[nFound]:=node;
      Inc(nFound);
      result:=True;
    end else begin
      result:=False;
    end;
  end;

  //startPendP̒ԂmidPɒڂāAmidNodestartNode,endNodeɂȂ܂ŒT
  procedure binSearchNode(startNode,endNode:TOctreeNode; const startP:D3DVECTOR; const endP:D3DVECTOR);
  var
    midNode:TOctreeNode;
    midP:D3DVECTOR;
  begin
    //ԂŃm[hT
    midP:=NowScale(NowAdd(startP,endP),0.5);
    midNode:=FindNodeFromPosition(midP);

    //startendǂȂOK
    if (midNode = startNode) Or (midNode=endNode) then
      exit;

    //ƂႤȂAXgɉŁA
    addNode(midNode);
    binSearchNode(startNode,midNode, startP,midP);
    binSearchNode(midNode,endNode, midP,endP);
  end;
begin
  nFound:=Length(FNodesThrough);

  startNode:=FindNodeFromPosition(startPos);
  addNode(startNode);

  endNode:=FindNodeFromPosition(endPos);
  if startNode <> endNode then begin
    addNode(endNode);
    binSearchNode(startNode, endNode, startPos, endPos);
  end;

  //ʂ̊i[
  SetLength(FNodesThrough, nFound);
  for i:=0 to nFound-1 do begin
    FNodesThrough[i]:=nodeFound[i];
  end;

end;


//GetNodesThroughŗ񋓂ꂽm[hXgNA
procedure TOctree.ClearNodesThrough;
begin
  FNodesThrough:=Nil;
end;


//FNodesThrough璆ɓĂOp`o
procedure TOctree.ListObstacles;
var
  i,j:Integer;
  nWall,prevNWall:DWord;
  indices:Array of DWord;
  srcIndex,destIndex:DWord;

  procedure QSortWallIndex(left,right:Integer);
  var
    i,j:Integer;
    s,t:DWord;
  begin
    if (left<right) then begin
      s:=indices[(left+right) Shr 1];
      i:=left-1;
      j:=right+1;
      while True do begin

        repeat
          Inc(i);
        until (indices[i]<=s);

        repeat
          Dec(j);
        until (indices[j]>=s);

        if (i>=j) then
          break;

        t:=indices[i];
        indices[i]:=indices[j];
        indices[j]:=t;

      end;
      QSortWallIndex(left,i-1);
      QSortWallIndex(j+1,right);
    end;
  end;
begin
  //m[hʉ߂ĂȂ
  if not Assigned(FNodesThrough) then begin
    FObstacles:=Nil;
    FObstaclesChecked:=Nil;
    exit;
  end;

  //ǂ̐Qbg
  nWall:=0;
  for i:=0 to Length(FNodesThrough)-1 do begin
    Inc(nWall, FNodesThrough[i].TrianglesCount);
  end;

  //ǂȂ
  if nWall = 0 then begin
    FObstacles:=Nil;
    FObstaclesChecked:=Nil;
    exit;
  end;

  //ǔԍQbg
  prevNWall:=0;
  SetLength(indices, nWall);
  for i:=0 to Length(FNodesThrough)-1 do begin
    for j:=0 to FNodesThrough[i].TrianglesCount-1 do
      indices[j+prevNWall]:=FNodesThrough[i].TriangleIndices[j];
    Inc(prevNWall,FNodesThrough[i].TrianglesCount);
  end;


  //\[gĂAd
  QSortWallIndex(0, nWall-1);
  srcIndex:=1;
  destIndex:=0;
  while srcIndex < nWall do begin
    if indices[destIndex] = indices[srcIndex] then begin
      Inc(srcIndex);
    end else begin
      Inc(destIndex);
      indices[destIndex]:=indices[srcIndex];
      Inc(srcIndex);
    end;
  end;
  nWall:=destIndex+1;

  //ʂ̊i[
  SetLength(FObstacles, nWall);
  SetLength(FObstaclesChecked, nWall);
  for i:=0 to nWall-1 do begin
    FObstacles[i]:=indices[i];
    FObstaclesChecked[i]:=False;
  end;

  indices:=Nil;
end;

function TOctree.GetTriangles(idx: Integer): TFacedTriangle3D;
begin
  result:=FTriangles[idx];
end;

procedure TOctree.SetTriangles(idx: Integer;
  const Value: TFacedTriangle3D);
begin
  FTriangles[idx]:=Value;
end;

function TOctree.GetEnumeratedObstacles(idx: DWord): Integer;
begin
  result:=FObstacles[idx];
end;

function TOctree.GetEnumeratedObstaclesCount: DWord;
begin
  if not Assigned(FObstacles) then
    result:=0
  else
    result:=Length(FObstacles);
end;

function TOctree.GetMaterials(idx: Integer): TMQOMaterialData;
begin
  result:=FMaterials[idx];
end;

procedure TOctree.SetMaterials(idx: Integer;
  const Value: TMQOMaterialData);
begin
  FMaterials[idx]:=Value;
end;


//OŃ}eAT
function TOctree.FindMaterial(const name: String): Integer;
var
  i:Integer;
begin
  result:=-1;
  
  for i:=0 to FMaterialCount-1 do begin
    if FMaterials[i].name = name then begin
      result:=i;
      break;
    end;
  end;
end;

function TOctree.FindObject(const name: String): Integer;
var
  i:Integer;
begin
  result:=-1;

  for i:=0 to FObjectCount-1 do begin
    if FObjectInfo[i].name = name then begin
      result:=i;
      break;
    end;
  end;
end;

//IuWFNgԍƃ}eAԍ烁bVt[T
function TOctree.FindMeshFrame(iObject, iMaterial: Integer): TSXFrame;
begin
  result:=FMeshFrames[iObject][iMaterial];
end;

//
function TOctree.FindMeshFrame(const objectName,
  materialName: String): TSXFrame;
var
  iMaterial,iObject:Integer;
begin
  result:=Nil;

  iObject:=FindObject(objectName);
  if iObject = -1 then
    exit;
  iMaterial:=FindMaterial(materialName);
  if iMaterial = -1 then
    exit;

end;



function TOctree.GetCollisionEnable(objectIndex: Integer): Boolean;
begin
  result:=FCollisionEnable[objectIndex];
end;

procedure TOctree.SetCollisionEnable(objectIndex: Integer; const Value: Boolean);
begin
  FCollisionEnable[objectIndex]:=Value;
end;

function TOctree.GetTianglesObjectIndex(idx: Integer): Integer;
begin
  result:=FTrianglesObjectIndex[idx];
end;

function TOctree.GetTrianglesMaterialIndex(idx: Integer): Integer;
begin
  result:=FTrianglesMaterialIndex[idx];
end;

function TOctree.getCollidedObstacles(idx: Integer): Integer;
begin
  result:=FCollidedObstacles[idx];
end;

{ TOctreeNode }

constructor TOctreeNode.Create(AOwner: TOctree);
var
  i:Integer;
begin
  FOwner:=AOwner;
  FTriangleIndices:=TOctreeIndexList.Create;

  for i:=oniFirstNode to oniLastNode do
    FChildren[i]:=Nil;

end;
destructor TOctreeNode.Destroy;
var
  i:Integer;
begin
  For i:=oniFirstNode to oniLastNode do begin
    if Assigned(FChildren[i]) then begin
      FreeAndNil(FChildren[i]);
    end;
  end;

  FreeAndNil(FTriangleIndices);
  inherited;
end;

//
//margińAm[hm̏dȂ蕔B0ƃm[h̋ڂł̓蔻肪R邱Ƃ
procedure TOctreeNode.Divide(newGridSize:Single; const newcenter:D3DVECTOR; level:Integer; margin:Single);
var
  i,j:Integer;
  half_grid:Single; //̃ObhTCY̔
  quad_grid:Single; //̃ObhTCY1/4
  //dstr:String;
  more:Boolean;
  moreFlag:Array of Boolean;
  triBounds:TBox3D; //}[WAOp`Ƃ̌ɗp`
  //dmy:TBox3D;

  function min3(a,b,c:Single):Single;
  begin
    result:=min(a,min(b,c));
  end;
  function max3(a,b,c:Single):Single;
  begin
    result:=max(a,max(b,c));
  end;
  function triangleBounds(tri:TFacedTriangle3D):TBox3D;
  begin
    result.Min:=Vector( min3(tri.A.x,tri.B.x,tri.C.x), min3(tri.A.y,tri.B.y,tri.C.y), min3(tri.A.z,tri.B.z,tri.C.z) );
    result.Max:=Vector( max3(tri.A.x,tri.B.x,tri.C.x), max3(tri.A.y,tri.B.y,tri.C.y), max3(tri.A.z,tri.B.z,tri.C.z) );
  end;
begin
  FCenter:=newCenter;
  half_grid:=newGridSize / 2.0;
  quad_grid:=half_grid / 2.0;
  FGridSize:=newGridSize;
  FBounds.Min:=NowSub(newCenter, Vector(half_grid,half_grid,half_grid));
  FBounds.Max:=NowAdd(newCenter, Vector(half_grid,half_grid,half_grid));

  //fobOp
  {
  if level = 0 then begin
    DGCarad_PutDebugMessage(Format('level=%d, Tris=%d, center=(%f,%f,%f), bounds=(%f,%f,%f)-(%f,%f,%f)',
    [level, TrianglesCount, center.x,center.y,center.z,
    bounds.min.x,bounds.min.y,bounds.min.z, bounds.max.x,bounds.max.y,bounds.max.z]));

    dstr:='Contain:';
    For i:=0 to TrianglesCount-1 do
      dstr:=dstr+IntToStr(TriangleIndices[i]) + ',';
    DGCarad_PutDebugMessage(dstr);
  end;
  }

  //Ȃ蕪[
  if level <= 0 then begin
    exit;
  end;

  //܂Aqm[hĂ܂(qm[h̃oE_vZԂ炷)
  for i:=oniFirstNode to oniLastNode do
    if Assigned(FChildren[i]) then
        FreeAndNil(FChildren[i]);

  For i:=oniFirstNode to oniLastNode do begin
    FChildren[i]:=TOctreeNode.Create(Owner);
    FChildren[i].Divide(
      half_grid,
      NowAdd( FBounds.Min, NowAdd(
        Vector(quad_grid,quad_grid,quad_grid),
        Vector( (i And 1) * half_grid, (i shr 2) * half_grid, ((i And 2) shr 1) * half_grid)
      )), -1, 0);
  end;

  //U蕪

  SetLength(moreFlag, TrianglesCount);
  For i:=0 to TrianglesCount-1 do begin
    moreFlag[i]:=True;
    For j:=oniFirstNode to oniLastNode do begin

      //eXgpAOp`̒_boundsɓĂ΂nj
      {
      For k:=0 to 2 do begin
        if NowPointInBox(Triangles[i].Vertices[k], FChildren[j].Bounds) then begin
          FChildren[j].TriangleIndices.Add(TriangleIndices[i]);
          break;
        end;
      end;
      }
      //eXgp2AOp`̃oEfBO{bNXAboundsɓĂOK
      {
      if NowIntersectBoxBox(dmy, triangleBounds(Triangles[i]), FChildren[j].Bounds) then begin
        FChildren[j].TriangleIndices.Add(TriangleIndices[i]);
      end;
      }
      //eXgp3AȂłnj
      //FChildren[j].TriangleIndices.Add(TriangleIndices[i]);

      triBounds.Min:=NowSub(FChildren[j].Center, NowScale(NowSub(FChildren[j].Bounds.Max,FChildren[j].Center) , (margin+1.0)));
      triBounds.Max:=NowAdd(FChildren[j].Center, NowScale(NowSub(FChildren[j].Bounds.Max,FChildren[j].Center) , (margin+1.0)));
      if NowIntersectTriangleBox(Triangles[i], triBounds) then begin
        {
        if ((TriangleIndices[i] = 0)) And (level=1) then begin
          with FChildren[j] do
            DGCarad_PutDebugMessage(Format('level=%d, Tris=%d, center=(%f,%f,%f), bounds=(%f,%f,%f)-(%f,%f,%f)',
              [level, TrianglesCount, center.x,center.y,center.z,
            bounds.min.x,bounds.min.y,bounds.min.z, bounds.max.x,bounds.max.y,bounds.max.z]));

          with Triangles[i] do
            DGCarad_PutDebugMessage(Format('(%f,%f,%f),(%f,%f,%f),(%f,%f,%f)',[A.x,A.y,A.z,B.x,B.y,B.z,C.x,c.Y,c.Z]));

        end;
        }
        FChildren[j].TriangleIndices.Add(TriangleIndices[i]);
        moreFlag[i]:=False;
      end;
    end;
  end;

  //R`FbN
  more:=False;
  for i:= 0 to TrianglesCount-1 do
    more:=more Or moreFlag[i];

  if more then begin
    DGCarad_PutDebugMessage(Format('TOctreeNode.Divide : qm[hɊi[ĂȂOp` c: level:%d',[level]));
    DGCarad_PutDebugMessage(Format('bound : min(%f,%f,%f) - max(%f,%f,%f)',
      [bounds.max.x,bounds.max.y,bounds.max.z, bounds.min.x,bounds.min.y,bounds.min.z]));


    for i:=0 to TrianglesCount-1 do begin
      if moreFlag[i] then begin
        DGCarad_PutDebugMessage(Format('#%d ... A(%f,%f,%f),B(%f,%f,%f),C(%f,%f,%f), N(%f,%f,%f)',
          [TriangleIndices[i],
          Triangles[i].A.x,Triangles[i].A.y,Triangles[i].A.z,
          Triangles[i].B.x,Triangles[i].B.y,Triangles[i].B.z,
          Triangles[i].C.x,Triangles[i].C.y,Triangles[i].C.z,
          Triangles[i].N.x,Triangles[i].N.y,Triangles[i].N.z]));
      end;
    end;
  end;

  moreFlag:=Nil;

  //Op`ĂȂm[h́AƂԂAłȂȂA
  for i:=oniFirstNode to oniLastNode do begin
    if FChildren[i].TrianglesCount = 0 then begin
      FreeAndNil(FChildren[i])
    end else begin
      FChildren[i].Divide(FChildren[i].GridSize, FChildren[i].Center, level-1, margin);
    end;
  end;

  //Ɋ܂܂ĂOp`Xg͖
  FTriangleIndices.Clear;

end;

function TOctreeNode.GetChildren(idx: TOctreeNodeIndex): TOctreeNode;
begin
  result:=FChildren[Ord(idx)];
end;




function TOctreeNode.GetTriangles(idx:Integer): TFacedTriangle3D;
begin
  result:=Owner.Triangles[TriangleIndices[idx]];
end;



function TOctreeNode.GetTrianglesCount: Integer;
begin
  result:=TriangleIndices.Count;
end;



{ TOctreeIndexList }

procedure TOctreeIndexList.Add(value: DWORD);
begin
  //eʂ𒴂A8vX
  if FCapacity <= FCount then
    SetNewCapacity(FCapacity + 8);

  FIndices[FCount]:=value;
  Inc(FCount);
end;

procedure TOctreeIndexList.Clear;
begin
  FCount:=0;
  SetNewCapacity(8);
end;

constructor TOctreeIndexList.Create;
begin
  inherited;

  Clear;
end;

procedure TOctreeIndexList.Delete(idx: Integer);
begin
  Dec(FCount);

  //8ȏ󂫂oAeʂ炷
  if (FCapacity - FCount) >= 8 then begin
    SetNewCapacity(FCapacity - 8);
  end;
end;

destructor TOctreeIndexList.Destroy;
begin
  FIndices:=Nil;
  inherited;
end;

function TOctreeIndexList.GetIndices(idx: Integer): DWORD;
begin
  result:=FIndices[idx];
end;

procedure TOctreeIndexList.SetIndices(idx: Integer; const Value: DWORD);
begin
  FIndices[idx]:=Value;
end;


procedure TOctreeIndexList.SetNewCapacity(newCapacity:DWord);
begin
  SetLength(FIndices, newCapacity);
  FCapacity:=newCapacity;
end;









function TOctree.GetObjects(idx:Integer):TMQOObjectData;
begin
  result:=FObjectInfo[idx];
end;


end.
